/*
  +----------------------------------------------------------------------+
  | PHP Version 5                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2012 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3.01 of the PHP license,      |
  | that is bundled with this package in the file LICENSE, and is        |
  | available through the world-wide-web at the following url:           |
  | http://www.php.net/license/3_01.txt                                  |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Author: Chung Leong <cleong@cal.berkeley.edu>                        |
  +----------------------------------------------------------------------+
*/

/* $Id$ */


enum qb_opcode {
	QB_NOP,
	QB_JMP,
	QB_RET,
	QB_INTR,
	QB_EXIT_I32,
	QB_FCALL_U32_U32_U32,
	QB_END_STATIC,
	QB_FORK_U32,
	QB_FORK_ID_U32,
	QB_FORK_ID_U32_SCA = QB_FORK_ID_U32,
	QB_FORK_ID_U32_ELE,
	QB_FORK_CNT_U32,
	QB_FORK_CNT_U32_SCA = QB_FORK_CNT_U32,
	QB_FORK_CNT_U32_ELE,
	QB_RESUME,
	QB_SPOON,
	QB_INC_IF_GT_U32_U32,
	QB_INC_IF_GT_U32_U32_SCA = QB_INC_IF_GT_U32_U32,
	QB_IF_LT_U32_U32,
	QB_IF_LT_U32_U32_SCA = QB_IF_LT_U32_U32,
	QB_IF_LT_U32_U32_ELE,
	QB_IF_LE_U32_U32,
	QB_IF_LE_U32_U32_SCA = QB_IF_LE_U32_U32,
	QB_IF_LE_U32_U32_ELE,
	QB_IDX_GUARD_U32_U32,
	QB_IDX_GUARD_ADD_U32_U32_U32_U32,
	QB_IDX_GUARD_MUL_U32_U32_U32_U32,
	QB_IDX_GUARD_MAC_U32_U32_U32_U32_U32,
	QB_SZ_GUARD_U32_U32,
	QB_SZ_GUARD_EX_U32_U32,
	QB_EXT_GUARD_U32_U32_U32,
	QB_EXT_GUARD_MUL_U32_U32_U32_U32_U32,
	QB_EXT_GUARD_SUB_U32_U32_U32,
	QB_EXT_GUARD_SUB_MUL_U32_U32_U32_U32,
	QB_IDX_CHECK_ADD_U32_U32_U32_I32_U32,
	QB_IDX_CHECK_MUL_U32_U32_U32_I32_U32,
	QB_IDX_CHECK_MAC_U32_U32_U32_U32_I32_U32,
	QB_IDX_ACCOM_U32_U32_U32_U32,
	QB_IDX_ACCOM_MUL_U32_U32_U32_U32_U32_U32_U32,
	QB_IDX_ACCOM_PUSH_U32_U32_U32_U32,
	QB_SZ_ACCOM_U32_U32_U32_U32,
	QB_SZ_ACCOM_DIM_U32_U32_U32_U32_U32_U32,
	QB_SZ_ACCOM_DIM2_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32,
	QB_SZ_ACCOM_DIM3_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32,
	QB_SZ_ACCOM_DIM4_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32,
	QB_SZ_ACCOM_DIM5_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32,
	QB_SZ_ACCOM_DIM6_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32,
	QB_SZ_ACCOM_DIM7_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32,
	QB_SZ_ACCOM_DIM8_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32,
	QB_SZ_CHOOSE_2_U32_U32_U32_U32_U32,
	QB_SZ_CHOOSE_2_TOP_U32_U32_U32,
	QB_SZ_CHOOSE_3_U32_U32_U32_U32_U32_U32_U32,
	QB_SZ_CHOOSE_3_TOP_U32_U32_U32_U32,
	QB_MUL_U32_U32_U32,
	QB_MUL_U32_U32_U32_SCA = QB_MUL_U32_U32_U32,
	QB_MUL_U32_U32_U32_ELE,
	QB_MUL_U32_U32_U32_MIO,
	QB_MAC_U32_U32_U32_U32,
	QB_MAC_U32_U32_U32_U32_SCA = QB_MAC_U32_U32_U32_U32,
	QB_MAC_U32_U32_U32_U32_ELE,
	QB_MAC_U32_U32_U32_U32_MIO,
	QB_DIV_U32_U32_U32,
	QB_DIV_U32_U32_U32_SCA = QB_DIV_U32_U32_U32,
	QB_DIV_U32_U32_U32_ELE,
	QB_DIV_U32_U32_U32_MIO,
	QB_MOD_U32_U32_U32,
	QB_MOD_U32_U32_U32_SCA = QB_MOD_U32_U32_U32,
	QB_MOD_U32_U32_U32_ELE,
	QB_MOD_U32_U32_U32_MIO,
	QB_SHL_U32_U32_U32,
	QB_SHL_U32_U32_U32_SCA = QB_SHL_U32_U32_U32,
	QB_SHL_U32_U32_U32_ELE,
	QB_SHL_U32_U32_U32_MIO,
	QB_SHR_U32_U32_U32,
	QB_SHR_U32_U32_U32_SCA = QB_SHR_U32_U32_U32,
	QB_SHR_U32_U32_U32_ELE,
	QB_SHR_U32_U32_U32_MIO,
	QB_LT_U32_U32_I32,
	QB_LT_U32_U32_I32_SCA = QB_LT_U32_U32_I32,
	QB_LT_U32_U32_I32_ELE,
	QB_LT_U32_U32_I32_MIO,
	QB_LE_U32_U32_I32,
	QB_LE_U32_U32_I32_SCA = QB_LE_U32_U32_I32,
	QB_LE_U32_U32_I32_ELE,
	QB_LE_U32_U32_I32_MIO,
	QB_LT_SET_U32_U32_I32,
	QB_LE_SET_U32_U32_I32,
	QB_MIN_U32_U32_U32,
	QB_MIN_U32_U32_U32_SCA = QB_MIN_U32_U32_U32,
	QB_MIN_U32_U32_U32_ELE,
	QB_MIN_U32_U32_U32_MIO,
	QB_MAX_U32_U32_U32,
	QB_MAX_U32_U32_U32_SCA = QB_MAX_U32_U32_U32,
	QB_MAX_U32_U32_U32_ELE,
	QB_MAX_U32_U32_U32_MIO,
	QB_RAND_U32_U32_U32,
	QB_RAND_U32_U32_U32_SCA = QB_RAND_U32_U32_U32,
	QB_RAND_U32_U32_U32_ELE,
	QB_RAND_U32_U32_U32_MIO,
	QB_MT_RAND_U32_U32_U32,
	QB_MT_RAND_U32_U32_U32_SCA = QB_MT_RAND_U32_U32_U32,
	QB_MT_RAND_U32_U32_U32_ELE,
	QB_MT_RAND_U32_U32_U32_MIO,
	QB_SORT_U32_U32,
	QB_RSORT_U32_U32,
	QB_AMIN_U32_U32,
	QB_AMIN_U32_U32_SCA = QB_AMIN_U32_U32,
	QB_AMIN_U32_U32_ELE,
	QB_AMAX_U32_U32,
	QB_AMAX_U32_U32_SCA = QB_AMAX_U32_U32,
	QB_AMAX_U32_U32_ELE,
	QB_APROD_U32_U32,
	QB_APROD_U32_U32_SCA = QB_APROD_U32_U32,
	QB_APROD_U32_U32_ELE,
	QB_ASUM_U32_U32,
	QB_ASUM_U32_U32_SCA = QB_ASUM_U32_U32,
	QB_ASUM_U32_U32_ELE,
	QB_RANGE_U32_U32_S32_U32,
	QB_RANGE_U32_U32_S32_U32_SCA = QB_RANGE_U32_U32_S32_U32,
	QB_RANGE_U32_U32_S32_U32_ELE,
	QB_SZ_RANGE_U32_U32_S32_U32,
	QB_SZ_RANGE_U32_U32_S32_U32_SCA = QB_SZ_RANGE_U32_U32_S32_U32,
	QB_SZ_RANGE_U32_U32_S32_U32_ELE,
	QB_SZ_APAD_U32_S32_U32,
	QB_ARAND_U32_U32_U32,
	QB_ARAND_U32_U32_U32_SCA = QB_ARAND_U32_U32_U32,
	QB_ARAND_U32_U32_U32_ELE,
	QB_IF_T_I32,
	QB_IF_T_I32_SCA = QB_IF_T_I32,
	QB_IF_T_I32_ELE,
	QB_IF_F_I32,
	QB_IF_F_I32_SCA = QB_IF_F_I32,
	QB_IF_F_I32_ELE,
	QB_IF_EQ_I32_I32,
	QB_IF_EQ_I32_I32_SCA = QB_IF_EQ_I32_I32,
	QB_IF_EQ_I32_I32_ELE,
	QB_IF_NE_I32_I32,
	QB_IF_NE_I32_I32_SCA = QB_IF_NE_I32_I32,
	QB_IF_NE_I32_I32_ELE,
	QB_IF_LT_S32_S32,
	QB_IF_LT_S32_S32_SCA = QB_IF_LT_S32_S32,
	QB_IF_LT_S32_S32_ELE,
	QB_IF_LE_S32_S32,
	QB_IF_LE_S32_S32_SCA = QB_IF_LE_S32_S32,
	QB_IF_LE_S32_S32_ELE,
	QB_SWITCH8_I32_I32,
	QB_SWITCH8_I32_I32_SCA = QB_SWITCH8_I32_I32,
	QB_SWITCH8_I32_I32_ELE,
	QB_SWITCH16_I32_I32,
	QB_SWITCH16_I32_I32_SCA = QB_SWITCH16_I32_I32,
	QB_SWITCH16_I32_I32_ELE,
	QB_SWITCH32_I32_I32,
	QB_SWITCH32_I32_I32_SCA = QB_SWITCH32_I32_I32,
	QB_SWITCH32_I32_I32_ELE,
	QB_SWITCH64_I32_I32,
	QB_SWITCH64_I32_I32_SCA = QB_SWITCH64_I32_I32,
	QB_SWITCH64_I32_I32_ELE,
	QB_SWITCH128_I32_I32,
	QB_SWITCH128_I32_I32_SCA = QB_SWITCH128_I32_I32,
	QB_SWITCH128_I32_I32_ELE,
	QB_SWITCH256_I32_I32,
	QB_SWITCH256_I32_I32_SCA = QB_SWITCH256_I32_I32,
	QB_SWITCH256_I32_I32_ELE,
	QB_SWITCH512_I32_I32,
	QB_SWITCH512_I32_I32_SCA = QB_SWITCH512_I32_I32,
	QB_SWITCH512_I32_I32_ELE,
	QB_SWITCH1024_I32_I32,
	QB_SWITCH1024_I32_I32_SCA = QB_SWITCH1024_I32_I32,
	QB_SWITCH1024_I32_I32_ELE,
	QB_INC_I32,
	QB_INC_I32_SCA = QB_INC_I32,
	QB_INC_I32_ELE,
	QB_INC_I32_MIO,
	QB_DEC_I32,
	QB_DEC_I32_SCA = QB_DEC_I32,
	QB_DEC_I32_ELE,
	QB_DEC_I32_MIO,
	QB_CBOOL_I32_I32_I32,
	QB_CBOOL_I32_I32_I32_SCA = QB_CBOOL_I32_I32_I32,
	QB_CBOOL_I32_I32_I32_ELE,
	QB_MOV_I32_I32,
	QB_MOV_I32_I32_SCA = QB_MOV_I32_I32,
	QB_MOV_I32_I32_ELE,
	QB_MOV_I32_I32_MIO,
	QB_ADD_I32_I32_I32,
	QB_ADD_I32_I32_I32_SCA = QB_ADD_I32_I32_I32,
	QB_ADD_I32_I32_I32_ELE,
	QB_ADD_I32_I32_I32_MIO,
	QB_MUL_S32_S32_S32,
	QB_MUL_S32_S32_S32_SCA = QB_MUL_S32_S32_S32,
	QB_MUL_S32_S32_S32_ELE,
	QB_MUL_S32_S32_S32_MIO,
	QB_MAC_S32_S32_S32_S32,
	QB_MAC_S32_S32_S32_S32_SCA = QB_MAC_S32_S32_S32_S32,
	QB_MAC_S32_S32_S32_S32_ELE,
	QB_MAC_S32_S32_S32_S32_MIO,
	QB_SUB_I32_I32_I32,
	QB_SUB_I32_I32_I32_SCA = QB_SUB_I32_I32_I32,
	QB_SUB_I32_I32_I32_ELE,
	QB_SUB_I32_I32_I32_MIO,
	QB_DIV_S32_S32_S32,
	QB_DIV_S32_S32_S32_SCA = QB_DIV_S32_S32_S32,
	QB_DIV_S32_S32_S32_ELE,
	QB_DIV_S32_S32_S32_MIO,
	QB_MOD_S32_S32_S32,
	QB_MOD_S32_S32_S32_SCA = QB_MOD_S32_S32_S32,
	QB_MOD_S32_S32_S32_ELE,
	QB_MOD_S32_S32_S32_MIO,
	QB_NEG_I32_I32,
	QB_NEG_I32_I32_SCA = QB_NEG_I32_I32,
	QB_NEG_I32_I32_ELE,
	QB_NEG_I32_I32_MIO,
	QB_BW_AND_I32_I32_I32,
	QB_BW_AND_I32_I32_I32_SCA = QB_BW_AND_I32_I32_I32,
	QB_BW_AND_I32_I32_I32_ELE,
	QB_BW_AND_I32_I32_I32_MIO,
	QB_BW_OR_I32_I32_I32,
	QB_BW_OR_I32_I32_I32_SCA = QB_BW_OR_I32_I32_I32,
	QB_BW_OR_I32_I32_I32_ELE,
	QB_BW_OR_I32_I32_I32_MIO,
	QB_BW_XOR_I32_I32_I32,
	QB_BW_XOR_I32_I32_I32_SCA = QB_BW_XOR_I32_I32_I32,
	QB_BW_XOR_I32_I32_I32_ELE,
	QB_BW_XOR_I32_I32_I32_MIO,
	QB_BW_NOT_I32_I32,
	QB_BW_NOT_I32_I32_SCA = QB_BW_NOT_I32_I32,
	QB_BW_NOT_I32_I32_ELE,
	QB_BW_NOT_I32_I32_MIO,
	QB_SHL_S32_S32_S32,
	QB_SHL_S32_S32_S32_SCA = QB_SHL_S32_S32_S32,
	QB_SHL_S32_S32_S32_ELE,
	QB_SHL_S32_S32_S32_MIO,
	QB_SHR_S32_S32_S32,
	QB_SHR_S32_S32_S32_SCA = QB_SHR_S32_S32_S32,
	QB_SHR_S32_S32_S32_ELE,
	QB_SHR_S32_S32_S32_MIO,
	QB_EQ_I32_I32_I32,
	QB_EQ_I32_I32_I32_SCA = QB_EQ_I32_I32_I32,
	QB_EQ_I32_I32_I32_ELE,
	QB_EQ_I32_I32_I32_MIO,
	QB_NE_I32_I32_I32,
	QB_NE_I32_I32_I32_SCA = QB_NE_I32_I32_I32,
	QB_NE_I32_I32_I32_ELE,
	QB_NE_I32_I32_I32_MIO,
	QB_LT_S32_S32_I32,
	QB_LT_S32_S32_I32_SCA = QB_LT_S32_S32_I32,
	QB_LT_S32_S32_I32_ELE,
	QB_LT_S32_S32_I32_MIO,
	QB_LE_S32_S32_I32,
	QB_LE_S32_S32_I32_SCA = QB_LE_S32_S32_I32,
	QB_LE_S32_S32_I32_ELE,
	QB_LE_S32_S32_I32_MIO,
	QB_EQ_SET_I32_I32_I32,
	QB_NE_SET_I32_I32_I32,
	QB_LT_SET_S32_S32_I32,
	QB_LE_SET_S32_S32_I32,
	QB_NOT_SET_I32_I32,
	QB_ANY_I32_I32,
	QB_ANY_I32_I32_SCA = QB_ANY_I32_I32,
	QB_ANY_I32_I32_ELE,
	QB_ALL_I32_I32,
	QB_ALL_I32_I32_SCA = QB_ALL_I32_I32,
	QB_ALL_I32_I32_ELE,
	QB_AND_I32_I32_I32,
	QB_OR_I32_I32_I32,
	QB_XOR_I32_I32_I32,
	QB_NOT_I32_I32,
	QB_ABS_S32_S32,
	QB_ABS_S32_S32_SCA = QB_ABS_S32_S32,
	QB_ABS_S32_S32_ELE,
	QB_ABS_S32_S32_MIO,
	QB_MIN_S32_S32_S32,
	QB_MIN_S32_S32_S32_SCA = QB_MIN_S32_S32_S32,
	QB_MIN_S32_S32_S32_ELE,
	QB_MIN_S32_S32_S32_MIO,
	QB_MAX_S32_S32_S32,
	QB_MAX_S32_S32_S32_SCA = QB_MAX_S32_S32_S32,
	QB_MAX_S32_S32_S32_ELE,
	QB_MAX_S32_S32_S32_MIO,
	QB_RAND_S32_S32_S32,
	QB_RAND_S32_S32_S32_SCA = QB_RAND_S32_S32_S32,
	QB_RAND_S32_S32_S32_ELE,
	QB_RAND_S32_S32_S32_MIO,
	QB_MT_RAND_S32_S32_S32,
	QB_MT_RAND_S32_S32_S32_SCA = QB_MT_RAND_S32_S32_S32,
	QB_MT_RAND_S32_S32_S32_ELE,
	QB_MT_RAND_S32_S32_S32_MIO,
	QB_SORT_U32_S32,
	QB_RSORT_U32_S32,
	QB_AMIN_S32_S32,
	QB_AMIN_S32_S32_SCA = QB_AMIN_S32_S32,
	QB_AMIN_S32_S32_ELE,
	QB_AMAX_S32_S32,
	QB_AMAX_S32_S32_SCA = QB_AMAX_S32_S32,
	QB_AMAX_S32_S32_ELE,
	QB_APROD_S32_S32,
	QB_APROD_S32_S32_SCA = QB_APROD_S32_S32,
	QB_APROD_S32_S32_ELE,
	QB_ASUM_S32_S32,
	QB_ASUM_S32_S32_SCA = QB_ASUM_S32_S32,
	QB_ASUM_S32_S32_ELE,
	QB_RANGE_S32_S32_S32_S32,
	QB_RANGE_S32_S32_S32_S32_SCA = QB_RANGE_S32_S32_S32_S32,
	QB_RANGE_S32_S32_S32_S32_ELE,
	QB_SZ_RANGE_S32_S32_S32_U32,
	QB_SZ_RANGE_S32_S32_S32_U32_SCA = QB_SZ_RANGE_S32_S32_S32_U32,
	QB_SZ_RANGE_S32_S32_S32_U32_ELE,
	QB_AFIND_I32_I32_I32,
	QB_AFIND_I32_I32_I32_SCA = QB_AFIND_I32_I32_I32,
	QB_AFIND_I32_I32_I32_ELE,
	QB_AFIND_I32_I32_I32_MIO,
	QB_AFILL_U32_I32_I32,
	QB_AFILL_U32_I32_I32_SCA = QB_AFILL_U32_I32_I32,
	QB_AFILL_U32_I32_I32_ELE,
	QB_AFILL_U32_I32_I32_MIO,
	QB_APOS_I32_I32_I32_I32,
	QB_APOS_I32_I32_I32_I32_SCA = QB_APOS_I32_I32_I32_I32,
	QB_APOS_I32_I32_I32_I32_ELE,
	QB_ARPOS_I32_I32_I32_I32,
	QB_ARPOS_I32_I32_I32_I32_SCA = QB_ARPOS_I32_I32_I32_I32,
	QB_ARPOS_I32_I32_I32_I32_ELE,
	QB_AREV_I32_U32_I32,
	QB_AUNIQ_I32_U32_I32,
	QB_SZ_AUNIQ_I32_U32_U32,
	QB_ACOL_I32_U32_U32_U32_I32,
	QB_ADIFF_I32_I32_U32_I32,
	QB_SZ_ADIFF_I32_I32_U32_U32,
	QB_AISECT_I32_I32_U32_I32,
	QB_SZ_AISECT_I32_I32_U32_U32,
	QB_SHUFFLE_U32_I32,
	QB_ASLICE_S32_S32_U32_U32_I32_I32,
	QB_ASLICE_S32_S32_U32_U32_I32_I32_SCA = QB_ASLICE_S32_S32_U32_U32_I32_I32,
	QB_ASLICE_S32_S32_U32_U32_I32_I32_ELE,
	QB_SZ_ASLICE_S32_S32_U32_U32,
	QB_SZ_ASLICE_S32_S32_U32_U32_SCA = QB_SZ_ASLICE_S32_S32_U32_U32,
	QB_SZ_ASLICE_S32_S32_U32_U32_ELE,
	QB_AREPLACE_I32_S32_S32_U32_U32_U32_I32,
	QB_AREPLACE_I32_S32_S32_U32_U32_U32_I32_SCA = QB_AREPLACE_I32_S32_S32_U32_U32_U32_I32,
	QB_AREPLACE_I32_S32_S32_U32_U32_U32_I32_ELE,
	QB_ARESIZE1_U32_U32_U32_U32_I32,
	QB_ARESIZE2_U32_U32_U32_U32_U32_U32_U32_I32,
	QB_ARESIZE3_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I32,
	QB_ARESIZE4_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I32,
	QB_ARESIZE5_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I32,
	QB_ARESIZE6_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I32,
	QB_ARESIZE7_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I32,
	QB_ARESIZE8_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I32,
	QB_APAD_I32_S32_I32_I32,
	QB_IF_EQ_F32_F32,
	QB_IF_EQ_F32_F32_SCA = QB_IF_EQ_F32_F32,
	QB_IF_EQ_F32_F32_ELE,
	QB_IF_NE_F32_F32,
	QB_IF_NE_F32_F32_SCA = QB_IF_NE_F32_F32,
	QB_IF_NE_F32_F32_ELE,
	QB_IF_LT_F32_F32,
	QB_IF_LT_F32_F32_SCA = QB_IF_LT_F32_F32,
	QB_IF_LT_F32_F32_ELE,
	QB_IF_LE_F32_F32,
	QB_IF_LE_F32_F32_SCA = QB_IF_LE_F32_F32,
	QB_IF_LE_F32_F32_ELE,
	QB_SWITCH8_F32_F32,
	QB_SWITCH8_F32_F32_SCA = QB_SWITCH8_F32_F32,
	QB_SWITCH8_F32_F32_ELE,
	QB_SWITCH16_F32_F32,
	QB_SWITCH16_F32_F32_SCA = QB_SWITCH16_F32_F32,
	QB_SWITCH16_F32_F32_ELE,
	QB_SWITCH32_F32_F32,
	QB_SWITCH32_F32_F32_SCA = QB_SWITCH32_F32_F32,
	QB_SWITCH32_F32_F32_ELE,
	QB_SWITCH64_F32_F32,
	QB_SWITCH64_F32_F32_SCA = QB_SWITCH64_F32_F32,
	QB_SWITCH64_F32_F32_ELE,
	QB_SWITCH128_F32_F32,
	QB_SWITCH128_F32_F32_SCA = QB_SWITCH128_F32_F32,
	QB_SWITCH128_F32_F32_ELE,
	QB_SWITCH256_F32_F32,
	QB_SWITCH256_F32_F32_SCA = QB_SWITCH256_F32_F32,
	QB_SWITCH256_F32_F32_ELE,
	QB_SWITCH512_F32_F32,
	QB_SWITCH512_F32_F32_SCA = QB_SWITCH512_F32_F32,
	QB_SWITCH512_F32_F32_ELE,
	QB_SWITCH1024_F32_F32,
	QB_SWITCH1024_F32_F32_SCA = QB_SWITCH1024_F32_F32,
	QB_SWITCH1024_F32_F32_ELE,
	QB_INC_F32,
	QB_INC_F32_SCA = QB_INC_F32,
	QB_INC_F32_ELE,
	QB_INC_F32_MIO,
	QB_DEC_F32,
	QB_DEC_F32_SCA = QB_DEC_F32,
	QB_DEC_F32_ELE,
	QB_DEC_F32_MIO,
	QB_CBOOL_F32_I32_I32,
	QB_CBOOL_F32_I32_I32_SCA = QB_CBOOL_F32_I32_I32,
	QB_CBOOL_F32_I32_I32_ELE,
	QB_MOV_F32_F32,
	QB_MOV_F32_F32_SCA = QB_MOV_F32_F32,
	QB_MOV_F32_F32_ELE,
	QB_MOV_F32_F32_MIO,
	QB_ADD_F32_F32_F32,
	QB_ADD_F32_F32_F32_SCA = QB_ADD_F32_F32_F32,
	QB_ADD_F32_F32_F32_ELE,
	QB_ADD_F32_F32_F32_MIO,
	QB_MUL_F32_F32_F32,
	QB_MUL_F32_F32_F32_SCA = QB_MUL_F32_F32_F32,
	QB_MUL_F32_F32_F32_ELE,
	QB_MUL_F32_F32_F32_MIO,
	QB_MAC_F32_F32_F32_F32,
	QB_MAC_F32_F32_F32_F32_SCA = QB_MAC_F32_F32_F32_F32,
	QB_MAC_F32_F32_F32_F32_ELE,
	QB_MAC_F32_F32_F32_F32_MIO,
	QB_SUB_F32_F32_F32,
	QB_SUB_F32_F32_F32_SCA = QB_SUB_F32_F32_F32,
	QB_SUB_F32_F32_F32_ELE,
	QB_SUB_F32_F32_F32_MIO,
	QB_DIV_F32_F32_F32,
	QB_DIV_F32_F32_F32_SCA = QB_DIV_F32_F32_F32,
	QB_DIV_F32_F32_F32_ELE,
	QB_DIV_F32_F32_F32_MIO,
	QB_MOD_F32_F32_F32,
	QB_MOD_F32_F32_F32_SCA = QB_MOD_F32_F32_F32,
	QB_MOD_F32_F32_F32_ELE,
	QB_MOD_F32_F32_F32_MIO,
	QB_MOD_FLR_F32_F32_F32,
	QB_MOD_FLR_F32_F32_F32_SCA = QB_MOD_FLR_F32_F32_F32,
	QB_MOD_FLR_F32_F32_F32_ELE,
	QB_MOD_FLR_F32_F32_F32_MIO,
	QB_NEG_F32_F32,
	QB_NEG_F32_F32_SCA = QB_NEG_F32_F32,
	QB_NEG_F32_F32_ELE,
	QB_NEG_F32_F32_MIO,
	QB_EQ_F32_F32_I32,
	QB_EQ_F32_F32_I32_SCA = QB_EQ_F32_F32_I32,
	QB_EQ_F32_F32_I32_ELE,
	QB_EQ_F32_F32_I32_MIO,
	QB_NE_F32_F32_I32,
	QB_NE_F32_F32_I32_SCA = QB_NE_F32_F32_I32,
	QB_NE_F32_F32_I32_ELE,
	QB_NE_F32_F32_I32_MIO,
	QB_LT_F32_F32_I32,
	QB_LT_F32_F32_I32_SCA = QB_LT_F32_F32_I32,
	QB_LT_F32_F32_I32_ELE,
	QB_LT_F32_F32_I32_MIO,
	QB_LE_F32_F32_I32,
	QB_LE_F32_F32_I32_SCA = QB_LE_F32_F32_I32,
	QB_LE_F32_F32_I32_ELE,
	QB_LE_F32_F32_I32_MIO,
	QB_EQ_SET_F32_F32_I32,
	QB_NE_SET_F32_F32_I32,
	QB_LT_SET_F32_F32_I32,
	QB_LE_SET_F32_F32_I32,
	QB_ABS_F32_F32,
	QB_ABS_F32_F32_SCA = QB_ABS_F32_F32,
	QB_ABS_F32_F32_ELE,
	QB_ABS_F32_F32_MIO,
	QB_MIN_F32_F32_F32,
	QB_MIN_F32_F32_F32_SCA = QB_MIN_F32_F32_F32,
	QB_MIN_F32_F32_F32_ELE,
	QB_MIN_F32_F32_F32_MIO,
	QB_MAX_F32_F32_F32,
	QB_MAX_F32_F32_F32_SCA = QB_MAX_F32_F32_F32,
	QB_MAX_F32_F32_F32_ELE,
	QB_MAX_F32_F32_F32_MIO,
	QB_SIN_F32_F32,
	QB_SIN_F32_F32_SCA = QB_SIN_F32_F32,
	QB_SIN_F32_F32_ELE,
	QB_SIN_F32_F32_MIO,
	QB_ASIN_F32_F32,
	QB_ASIN_F32_F32_SCA = QB_ASIN_F32_F32,
	QB_ASIN_F32_F32_ELE,
	QB_ASIN_F32_F32_MIO,
	QB_COS_F32_F32,
	QB_COS_F32_F32_SCA = QB_COS_F32_F32,
	QB_COS_F32_F32_ELE,
	QB_COS_F32_F32_MIO,
	QB_ACOS_F32_F32,
	QB_ACOS_F32_F32_SCA = QB_ACOS_F32_F32,
	QB_ACOS_F32_F32_ELE,
	QB_ACOS_F32_F32_MIO,
	QB_TAN_F32_F32,
	QB_TAN_F32_F32_SCA = QB_TAN_F32_F32,
	QB_TAN_F32_F32_ELE,
	QB_TAN_F32_F32_MIO,
	QB_ATAN_F32_F32,
	QB_ATAN_F32_F32_SCA = QB_ATAN_F32_F32,
	QB_ATAN_F32_F32_ELE,
	QB_ATAN_F32_F32_MIO,
	QB_ATAN2_F32_F32_F32,
	QB_ATAN2_F32_F32_F32_SCA = QB_ATAN2_F32_F32_F32,
	QB_ATAN2_F32_F32_F32_ELE,
	QB_ATAN2_F32_F32_F32_MIO,
	QB_SINH_F32_F32,
	QB_SINH_F32_F32_SCA = QB_SINH_F32_F32,
	QB_SINH_F32_F32_ELE,
	QB_SINH_F32_F32_MIO,
	QB_ASINH_F32_F32,
	QB_ASINH_F32_F32_SCA = QB_ASINH_F32_F32,
	QB_ASINH_F32_F32_ELE,
	QB_ASINH_F32_F32_MIO,
	QB_COSH_F32_F32,
	QB_COSH_F32_F32_SCA = QB_COSH_F32_F32,
	QB_COSH_F32_F32_ELE,
	QB_COSH_F32_F32_MIO,
	QB_ACOSH_F32_F32,
	QB_ACOSH_F32_F32_SCA = QB_ACOSH_F32_F32,
	QB_ACOSH_F32_F32_ELE,
	QB_ACOSH_F32_F32_MIO,
	QB_TANH_F32_F32,
	QB_TANH_F32_F32_SCA = QB_TANH_F32_F32,
	QB_TANH_F32_F32_ELE,
	QB_TANH_F32_F32_MIO,
	QB_ATANH_F32_F32,
	QB_ATANH_F32_F32_SCA = QB_ATANH_F32_F32,
	QB_ATANH_F32_F32_ELE,
	QB_ATANH_F32_F32_MIO,
	QB_CEIL_F32_F32,
	QB_CEIL_F32_F32_SCA = QB_CEIL_F32_F32,
	QB_CEIL_F32_F32_ELE,
	QB_CEIL_F32_F32_MIO,
	QB_FLOOR_F32_F32,
	QB_FLOOR_F32_F32_SCA = QB_FLOOR_F32_F32,
	QB_FLOOR_F32_F32_ELE,
	QB_FLOOR_F32_F32_MIO,
	QB_RINT_F32_F32,
	QB_RINT_F32_F32_SCA = QB_RINT_F32_F32,
	QB_RINT_F32_F32_ELE,
	QB_RINT_F32_F32_MIO,
	QB_ROUND_F32_F32,
	QB_ROUND_F32_F32_SCA = QB_ROUND_F32_F32,
	QB_ROUND_F32_F32_ELE,
	QB_ROUND_F32_F32_MIO,
	QB_LOG_F32_F32,
	QB_LOG_F32_F32_SCA = QB_LOG_F32_F32,
	QB_LOG_F32_F32_ELE,
	QB_LOG_F32_F32_MIO,
	QB_LOG1P_F32_F32,
	QB_LOG1P_F32_F32_SCA = QB_LOG1P_F32_F32,
	QB_LOG1P_F32_F32_ELE,
	QB_LOG1P_F32_F32_MIO,
	QB_LOG2_F32_F32,
	QB_LOG2_F32_F32_SCA = QB_LOG2_F32_F32,
	QB_LOG2_F32_F32_ELE,
	QB_LOG2_F32_F32_MIO,
	QB_LOG10_F32_F32,
	QB_LOG10_F32_F32_SCA = QB_LOG10_F32_F32,
	QB_LOG10_F32_F32_ELE,
	QB_LOG10_F32_F32_MIO,
	QB_EXP_F32_F32,
	QB_EXP_F32_F32_SCA = QB_EXP_F32_F32,
	QB_EXP_F32_F32_ELE,
	QB_EXP_F32_F32_MIO,
	QB_EXPM1_F32_F32,
	QB_EXPM1_F32_F32_SCA = QB_EXPM1_F32_F32,
	QB_EXPM1_F32_F32_ELE,
	QB_EXPM1_F32_F32_MIO,
	QB_EXP2_F32_F32,
	QB_EXP2_F32_F32_SCA = QB_EXP2_F32_F32,
	QB_EXP2_F32_F32_ELE,
	QB_EXP2_F32_F32_MIO,
	QB_POW_F32_F32_F32,
	QB_POW_F32_F32_F32_SCA = QB_POW_F32_F32_F32,
	QB_POW_F32_F32_F32_ELE,
	QB_POW_F32_F32_F32_MIO,
	QB_SQRT_F32_F32,
	QB_SQRT_F32_F32_SCA = QB_SQRT_F32_F32,
	QB_SQRT_F32_F32_ELE,
	QB_SQRT_F32_F32_MIO,
	QB_HYPOT_F32_F32_F32,
	QB_HYPOT_F32_F32_F32_SCA = QB_HYPOT_F32_F32_F32,
	QB_HYPOT_F32_F32_F32_ELE,
	QB_HYPOT_F32_F32_F32_MIO,
	QB_LCG_F32,
	QB_LCG_F32_SCA = QB_LCG_F32,
	QB_LCG_F32_ELE,
	QB_LCG_F32_MIO,
	QB_FIN_F32_I32,
	QB_FIN_F32_I32_SCA = QB_FIN_F32_I32,
	QB_FIN_F32_I32_ELE,
	QB_FIN_F32_I32_MIO,
	QB_INF_F32_I32,
	QB_INF_F32_I32_SCA = QB_INF_F32_I32,
	QB_INF_F32_I32_ELE,
	QB_INF_F32_I32_MIO,
	QB_NAN_F32_I32,
	QB_NAN_F32_I32_SCA = QB_NAN_F32_I32,
	QB_NAN_F32_I32_ELE,
	QB_NAN_F32_I32_MIO,
	QB_RSQRT_F32_F32,
	QB_RSQRT_F32_F32_SCA = QB_RSQRT_F32_F32,
	QB_RSQRT_F32_F32_ELE,
	QB_RSQRT_F32_F32_MIO,
	QB_CLAMP_F32_F32_F32_F32,
	QB_CLAMP_F32_F32_F32_F32_SCA = QB_CLAMP_F32_F32_F32_F32,
	QB_CLAMP_F32_F32_F32_F32_ELE,
	QB_CLAMP_F32_F32_F32_F32_MIO,
	QB_FRACT_F32_F32,
	QB_FRACT_F32_F32_SCA = QB_FRACT_F32_F32,
	QB_FRACT_F32_F32_ELE,
	QB_FRACT_F32_F32_MIO,
	QB_MIX_F32_F32_F32_F32,
	QB_MIX_F32_F32_F32_F32_SCA = QB_MIX_F32_F32_F32_F32,
	QB_MIX_F32_F32_F32_F32_ELE,
	QB_MIX_F32_F32_F32_F32_MIO,
	QB_SIGN_F32_F32,
	QB_SIGN_F32_F32_SCA = QB_SIGN_F32_F32,
	QB_SIGN_F32_F32_ELE,
	QB_SIGN_F32_F32_MIO,
	QB_STEP_F32_F32_F32,
	QB_STEP_F32_F32_F32_SCA = QB_STEP_F32_F32_F32,
	QB_STEP_F32_F32_F32_ELE,
	QB_STEP_F32_F32_F32_MIO,
	QB_SSTEP_F32_F32_F32_F32,
	QB_SSTEP_F32_F32_F32_F32_SCA = QB_SSTEP_F32_F32_F32_F32,
	QB_SSTEP_F32_F32_F32_F32_ELE,
	QB_SSTEP_F32_F32_F32_F32_MIO,
	QB_RAD2DEG_F32_F32,
	QB_RAD2DEG_F32_F32_SCA = QB_RAD2DEG_F32_F32,
	QB_RAD2DEG_F32_F32_ELE,
	QB_RAD2DEG_F32_F32_MIO,
	QB_DEG2RAD_F32_F32,
	QB_DEG2RAD_F32_F32_SCA = QB_DEG2RAD_F32_F32,
	QB_DEG2RAD_F32_F32_ELE,
	QB_DEG2RAD_F32_F32_MIO,
	QB_ROUND_F32_I32_I32_F32,
	QB_ROUND_F32_I32_I32_F32_SCA = QB_ROUND_F32_I32_I32_F32,
	QB_ROUND_F32_I32_I32_F32_ELE,
	QB_ROUND_F32_I32_I32_F32_MIO,
	QB_SORT_U32_F32,
	QB_RSORT_U32_F32,
	QB_AMIN_F32_F32,
	QB_AMIN_F32_F32_SCA = QB_AMIN_F32_F32,
	QB_AMIN_F32_F32_ELE,
	QB_AMAX_F32_F32,
	QB_AMAX_F32_F32_SCA = QB_AMAX_F32_F32,
	QB_AMAX_F32_F32_ELE,
	QB_APROD_F32_F32,
	QB_APROD_F32_F32_SCA = QB_APROD_F32_F32,
	QB_APROD_F32_F32_ELE,
	QB_ASUM_F32_F32,
	QB_ASUM_F32_F32_SCA = QB_ASUM_F32_F32,
	QB_ASUM_F32_F32_ELE,
	QB_RANGE_F32_F32_F32_F32,
	QB_RANGE_F32_F32_F32_F32_SCA = QB_RANGE_F32_F32_F32_F32,
	QB_RANGE_F32_F32_F32_F32_ELE,
	QB_SZ_RANGE_F32_F32_F32_U32,
	QB_SZ_RANGE_F32_F32_F32_U32_SCA = QB_SZ_RANGE_F32_F32_F32_U32,
	QB_SZ_RANGE_F32_F32_F32_U32_ELE,
	QB_AFIND_F32_F32_I32,
	QB_AFIND_F32_F32_I32_SCA = QB_AFIND_F32_F32_I32,
	QB_AFIND_F32_F32_I32_ELE,
	QB_AFIND_F32_F32_I32_MIO,
	QB_AFILL_U32_F32_F32,
	QB_AFILL_U32_F32_F32_SCA = QB_AFILL_U32_F32_F32,
	QB_AFILL_U32_F32_F32_ELE,
	QB_AFILL_U32_F32_F32_MIO,
	QB_APOS_F32_F32_I32_I32,
	QB_APOS_F32_F32_I32_I32_SCA = QB_APOS_F32_F32_I32_I32,
	QB_APOS_F32_F32_I32_I32_ELE,
	QB_ARPOS_F32_F32_I32_I32,
	QB_ARPOS_F32_F32_I32_I32_SCA = QB_ARPOS_F32_F32_I32_I32,
	QB_ARPOS_F32_F32_I32_I32_ELE,
	QB_AREV_F32_U32_F32,
	QB_AUNIQ_F32_U32_F32,
	QB_SZ_AUNIQ_F32_U32_U32,
	QB_ACOL_F32_U32_U32_U32_F32,
	QB_ADIFF_F32_F32_U32_F32,
	QB_SZ_ADIFF_F32_F32_U32_U32,
	QB_AISECT_F32_F32_U32_F32,
	QB_SZ_AISECT_F32_F32_U32_U32,
	QB_SHUFFLE_U32_F32,
	QB_ASLICE_S32_S32_U32_U32_F32_F32,
	QB_ASLICE_S32_S32_U32_U32_F32_F32_SCA = QB_ASLICE_S32_S32_U32_U32_F32_F32,
	QB_ASLICE_S32_S32_U32_U32_F32_F32_ELE,
	QB_AREPLACE_F32_S32_S32_U32_U32_U32_F32,
	QB_AREPLACE_F32_S32_S32_U32_U32_U32_F32_SCA = QB_AREPLACE_F32_S32_S32_U32_U32_U32_F32,
	QB_AREPLACE_F32_S32_S32_U32_U32_U32_F32_ELE,
	QB_ARESIZE1_U32_U32_U32_U32_F32,
	QB_ARESIZE2_U32_U32_U32_U32_U32_U32_U32_F32,
	QB_ARESIZE3_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_F32,
	QB_ARESIZE4_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_F32,
	QB_ARESIZE5_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_F32,
	QB_ARESIZE6_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_F32,
	QB_ARESIZE7_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_F32,
	QB_ARESIZE8_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_F32,
	QB_APAD_F32_S32_F32_F32,
	QB_SAMPLE_NN_4X_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_NN_4X_F32_U32_U32_F32_F32_F32_SCA = QB_SAMPLE_NN_4X_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_NN_4X_F32_U32_U32_F32_F32_F32_ELE,
	QB_SAMPLE_NN_4X_F32_U32_U32_F32_F32_F32_MIO,
	QB_SAMPLE_NN_3X_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_NN_3X_F32_U32_U32_F32_F32_F32_SCA = QB_SAMPLE_NN_3X_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_NN_3X_F32_U32_U32_F32_F32_F32_ELE,
	QB_SAMPLE_NN_3X_F32_U32_U32_F32_F32_F32_MIO,
	QB_SAMPLE_NN_2X_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_NN_2X_F32_U32_U32_F32_F32_F32_SCA = QB_SAMPLE_NN_2X_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_NN_2X_F32_U32_U32_F32_F32_F32_ELE,
	QB_SAMPLE_NN_2X_F32_U32_U32_F32_F32_F32_MIO,
	QB_SAMPLE_NN_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_NN_F32_U32_U32_F32_F32_F32_SCA = QB_SAMPLE_NN_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_NN_F32_U32_U32_F32_F32_F32_ELE,
	QB_SAMPLE_NN_F32_U32_U32_F32_F32_F32_MIO,
	QB_SAMPLE_BL_4X_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_BL_4X_F32_U32_U32_F32_F32_F32_SCA = QB_SAMPLE_BL_4X_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_BL_4X_F32_U32_U32_F32_F32_F32_ELE,
	QB_SAMPLE_BL_4X_F32_U32_U32_F32_F32_F32_MIO,
	QB_SAMPLE_BL_3X_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_BL_3X_F32_U32_U32_F32_F32_F32_SCA = QB_SAMPLE_BL_3X_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_BL_3X_F32_U32_U32_F32_F32_F32_ELE,
	QB_SAMPLE_BL_3X_F32_U32_U32_F32_F32_F32_MIO,
	QB_SAMPLE_BL_2X_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_BL_2X_F32_U32_U32_F32_F32_F32_SCA = QB_SAMPLE_BL_2X_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_BL_2X_F32_U32_U32_F32_F32_F32_ELE,
	QB_SAMPLE_BL_2X_F32_U32_U32_F32_F32_F32_MIO,
	QB_SAMPLE_BL_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_BL_F32_U32_U32_F32_F32_F32_SCA = QB_SAMPLE_BL_F32_U32_U32_F32_F32_F32,
	QB_SAMPLE_BL_F32_U32_U32_F32_F32_F32_ELE,
	QB_SAMPLE_BL_F32_U32_U32_F32_F32_F32_MIO,
	QB_BLEND_2X_F32_F32_F32,
	QB_BLEND_2X_F32_F32_F32_MIO,
	QB_BLEND_4X_F32_F32_F32,
	QB_BLEND_4X_F32_F32_F32_MIO,
	QB_PREMULT_F32_F32,
	QB_PREMULT_F32_F32_MIO,
	QB_UNPREMULT_F32_F32,
	QB_UNPREMULT_F32_F32_MIO,
	QB_RGB2HSV_3X_F32_F32,
	QB_RGB2HSV_3X_F32_F32_MIO,
	QB_RGB2HSV_4X_F32_F32,
	QB_RGB2HSV_4X_F32_F32_MIO,
	QB_HSV2RGB_3X_F32_F32,
	QB_HSV2RGB_3X_F32_F32_MIO,
	QB_HSV2RGB_4X_F32_F32,
	QB_HSV2RGB_4X_F32_F32_MIO,
	QB_RGB2HSL_3X_F32_F32,
	QB_RGB2HSL_3X_F32_F32_MIO,
	QB_RGB2HSL_4X_F32_F32,
	QB_RGB2HSL_4X_F32_F32_MIO,
	QB_HSL2RGB_3X_F32_F32,
	QB_HSL2RGB_3X_F32_F32_MIO,
	QB_HSL2RGB_4X_F32_F32,
	QB_HSL2RGB_4X_F32_F32_MIO,
	QB_MUL_MM_CM_4X_F32_F32_F32,
	QB_MUL_MM_CM_4X_F32_F32_F32_MIO,
	QB_MUL_MV_CM_4X_F32_F32_F32,
	QB_MUL_MV_CM_4X_F32_F32_F32_MIO,
	QB_MUL_VM_CM_4X_F32_F32_F32,
	QB_MUL_VM_CM_4X_F32_F32_F32_MIO,
	QB_MTRAN_4X_F32_F32,
	QB_MTRAN_4X_F32_F32_MIO,
	QB_MINV_4X_F32_F32,
	QB_MINV_4X_F32_F32_MIO,
	QB_MDET_4X_F32_F32,
	QB_MDET_4X_F32_F32_SCA = QB_MDET_4X_F32_F32,
	QB_MDET_4X_F32_F32_ELE,
	QB_MDET_4X_F32_F32_MIO,
	QB_DOT_4X_F32_F32_F32,
	QB_DOT_4X_F32_F32_F32_SCA = QB_DOT_4X_F32_F32_F32,
	QB_DOT_4X_F32_F32_F32_ELE,
	QB_DOT_4X_F32_F32_F32_MIO,
	QB_LEN_4X_F32_F32,
	QB_LEN_4X_F32_F32_SCA = QB_LEN_4X_F32_F32,
	QB_LEN_4X_F32_F32_ELE,
	QB_LEN_4X_F32_F32_MIO,
	QB_DIS_4X_F32_F32_F32,
	QB_DIS_4X_F32_F32_F32_SCA = QB_DIS_4X_F32_F32_F32,
	QB_DIS_4X_F32_F32_F32_ELE,
	QB_DIS_4X_F32_F32_F32_MIO,
	QB_NORM_4X_F32_F32,
	QB_NORM_4X_F32_F32_MIO,
	QB_CROSS_4X_F32_F32_F32_F32,
	QB_CROSS_4X_F32_F32_F32_F32_MIO,
	QB_FORE_4X_F32_F32_F32,
	QB_FORE_4X_F32_F32_F32_MIO,
	QB_REFL_4X_F32_F32_F32,
	QB_REFL_4X_F32_F32_F32_MIO,
	QB_REFR_4X_F32_F32_F32_F32,
	QB_REFR_4X_F32_F32_F32_F32_MIO,
	QB_TRAN_CM_4X_F32_F32_F32,
	QB_TRAN_CM_4X_F32_F32_F32_MIO,
	QB_TRAN_RM_4X_F32_F32_F32,
	QB_TRAN_RM_4X_F32_F32_F32_MIO,
	QB_MOV_4X_F32_F32,
	QB_MOV_4X_F32_F32_MIO,
	QB_ADD_4X_F32_F32_F32,
	QB_ADD_4X_F32_F32_F32_MIO,
	QB_SUB_4X_F32_F32_F32,
	QB_SUB_4X_F32_F32_F32_MIO,
	QB_MUL_4X_F32_F32_F32,
	QB_MUL_4X_F32_F32_F32_MIO,
	QB_DIV_4X_F32_F32_F32,
	QB_DIV_4X_F32_F32_F32_MIO,
	QB_MOD_4X_F32_F32_F32,
	QB_MOD_4X_F32_F32_F32_MIO,
	QB_NEG_4X_F32_F32,
	QB_NEG_4X_F32_F32_MIO,
	QB_INC_4X_F32,
	QB_INC_4X_F32_MIO,
	QB_DEC_4X_F32,
	QB_DEC_4X_F32_MIO,
	QB_MAC_4X_F32_F32_F32_F32,
	QB_MAC_4X_F32_F32_F32_F32_MIO,
	QB_MUL_MM_CM_3X_F32_F32_F32,
	QB_MUL_MM_CM_3X_F32_F32_F32_MIO,
	QB_MUL_MV_CM_3X_F32_F32_F32,
	QB_MUL_MV_CM_3X_F32_F32_F32_MIO,
	QB_MUL_VM_CM_3X_F32_F32_F32,
	QB_MUL_VM_CM_3X_F32_F32_F32_MIO,
	QB_MUL_MM_CM_PAD_3X_F32_F32_F32,
	QB_MUL_MV_CM_PAD_3X_F32_F32_F32,
	QB_MUL_VM_CM_PAD_3X_F32_F32_F32,
	QB_MTRAN_3X_F32_F32,
	QB_MTRAN_3X_F32_F32_MIO,
	QB_MINV_3X_F32_F32,
	QB_MINV_3X_F32_F32_MIO,
	QB_MDET_3X_F32_F32,
	QB_MDET_3X_F32_F32_SCA = QB_MDET_3X_F32_F32,
	QB_MDET_3X_F32_F32_ELE,
	QB_MDET_3X_F32_F32_MIO,
	QB_DOT_3X_F32_F32_F32,
	QB_DOT_3X_F32_F32_F32_SCA = QB_DOT_3X_F32_F32_F32,
	QB_DOT_3X_F32_F32_F32_ELE,
	QB_DOT_3X_F32_F32_F32_MIO,
	QB_LEN_3X_F32_F32,
	QB_LEN_3X_F32_F32_SCA = QB_LEN_3X_F32_F32,
	QB_LEN_3X_F32_F32_ELE,
	QB_LEN_3X_F32_F32_MIO,
	QB_DIS_3X_F32_F32_F32,
	QB_DIS_3X_F32_F32_F32_SCA = QB_DIS_3X_F32_F32_F32,
	QB_DIS_3X_F32_F32_F32_ELE,
	QB_DIS_3X_F32_F32_F32_MIO,
	QB_NORM_3X_F32_F32,
	QB_NORM_3X_F32_F32_MIO,
	QB_CROSS_3X_F32_F32_F32,
	QB_CROSS_3X_F32_F32_F32_MIO,
	QB_FORE_3X_F32_F32_F32,
	QB_FORE_3X_F32_F32_F32_MIO,
	QB_REFL_3X_F32_F32_F32,
	QB_REFL_3X_F32_F32_F32_MIO,
	QB_REFR_3X_F32_F32_F32_F32,
	QB_REFR_3X_F32_F32_F32_F32_MIO,
	QB_TRAN_CM_3X_F32_F32_F32,
	QB_TRAN_CM_3X_F32_F32_F32_MIO,
	QB_TRAN_RM_3X_F32_F32_F32,
	QB_TRAN_RM_3X_F32_F32_F32_MIO,
	QB_MOV_3X_F32_F32,
	QB_MOV_3X_F32_F32_MIO,
	QB_ADD_3X_F32_F32_F32,
	QB_ADD_3X_F32_F32_F32_MIO,
	QB_SUB_3X_F32_F32_F32,
	QB_SUB_3X_F32_F32_F32_MIO,
	QB_MUL_3X_F32_F32_F32,
	QB_MUL_3X_F32_F32_F32_MIO,
	QB_DIV_3X_F32_F32_F32,
	QB_DIV_3X_F32_F32_F32_MIO,
	QB_MOD_3X_F32_F32_F32,
	QB_MOD_3X_F32_F32_F32_MIO,
	QB_NEG_3X_F32_F32,
	QB_NEG_3X_F32_F32_MIO,
	QB_INC_3X_F32,
	QB_INC_3X_F32_MIO,
	QB_DEC_3X_F32,
	QB_DEC_3X_F32_MIO,
	QB_MAC_3X_F32_F32_F32_F32,
	QB_MAC_3X_F32_F32_F32_F32_MIO,
	QB_MUL_MM_CM_2X_F32_F32_F32,
	QB_MUL_MM_CM_2X_F32_F32_F32_MIO,
	QB_MUL_MV_CM_2X_F32_F32_F32,
	QB_MUL_MV_CM_2X_F32_F32_F32_MIO,
	QB_MUL_VM_CM_2X_F32_F32_F32,
	QB_MUL_VM_CM_2X_F32_F32_F32_MIO,
	QB_MTRAN_2X_F32_F32,
	QB_MTRAN_2X_F32_F32_MIO,
	QB_MINV_2X_F32_F32,
	QB_MINV_2X_F32_F32_MIO,
	QB_MDET_2X_F32_F32,
	QB_MDET_2X_F32_F32_SCA = QB_MDET_2X_F32_F32,
	QB_MDET_2X_F32_F32_ELE,
	QB_MDET_2X_F32_F32_MIO,
	QB_DOT_2X_F32_F32_F32,
	QB_DOT_2X_F32_F32_F32_SCA = QB_DOT_2X_F32_F32_F32,
	QB_DOT_2X_F32_F32_F32_ELE,
	QB_DOT_2X_F32_F32_F32_MIO,
	QB_LEN_2X_F32_F32,
	QB_LEN_2X_F32_F32_SCA = QB_LEN_2X_F32_F32,
	QB_LEN_2X_F32_F32_ELE,
	QB_LEN_2X_F32_F32_MIO,
	QB_DIS_2X_F32_F32_F32,
	QB_DIS_2X_F32_F32_F32_SCA = QB_DIS_2X_F32_F32_F32,
	QB_DIS_2X_F32_F32_F32_ELE,
	QB_DIS_2X_F32_F32_F32_MIO,
	QB_NORM_2X_F32_F32,
	QB_NORM_2X_F32_F32_MIO,
	QB_CROSS_2X_F32_F32_F32,
	QB_CROSS_2X_F32_F32_F32_MIO,
	QB_FORE_2X_F32_F32_F32,
	QB_FORE_2X_F32_F32_F32_MIO,
	QB_REFL_2X_F32_F32_F32,
	QB_REFL_2X_F32_F32_F32_MIO,
	QB_REFR_2X_F32_F32_F32_F32,
	QB_REFR_2X_F32_F32_F32_F32_MIO,
	QB_TRAN_CM_2X_F32_F32_F32,
	QB_TRAN_CM_2X_F32_F32_F32_MIO,
	QB_TRAN_RM_2X_F32_F32_F32,
	QB_TRAN_RM_2X_F32_F32_F32_MIO,
	QB_MOV_2X_F32_F32,
	QB_MOV_2X_F32_F32_MIO,
	QB_ADD_2X_F32_F32_F32,
	QB_ADD_2X_F32_F32_F32_MIO,
	QB_SUB_2X_F32_F32_F32,
	QB_SUB_2X_F32_F32_F32_MIO,
	QB_MUL_2X_F32_F32_F32,
	QB_MUL_2X_F32_F32_F32_MIO,
	QB_DIV_2X_F32_F32_F32,
	QB_DIV_2X_F32_F32_F32_MIO,
	QB_MOD_2X_F32_F32_F32,
	QB_MOD_2X_F32_F32_F32_MIO,
	QB_NEG_2X_F32_F32,
	QB_NEG_2X_F32_F32_MIO,
	QB_INC_2X_F32,
	QB_INC_2X_F32_MIO,
	QB_DEC_2X_F32,
	QB_DEC_2X_F32_MIO,
	QB_MAC_2X_F32_F32_F32_F32,
	QB_MAC_2X_F32_F32_F32_F32_MIO,
	QB_MUL_MM_CM_F32_F32_U32_U32_U32_F32,
	QB_MUL_MM_CM_F32_F32_U32_U32_U32_F32_MIO,
	QB_MUL_MV_CM_F32_F32_U32_U32_F32,
	QB_MUL_MV_CM_F32_F32_U32_U32_F32_MIO,
	QB_MUL_VM_CM_F32_F32_U32_U32_F32,
	QB_MUL_VM_CM_F32_F32_U32_U32_F32_MIO,
	QB_MTRAN_F32_U32_U32_F32,
	QB_MTRAN_F32_U32_U32_F32_MIO,
	QB_MINV_F32_U32_F32,
	QB_MINV_F32_U32_F32_MIO,
	QB_MDET_F32_U32_F32,
	QB_MDET_F32_U32_F32_SCA = QB_MDET_F32_U32_F32,
	QB_MDET_F32_U32_F32_ELE,
	QB_MDET_F32_U32_F32_MIO,
	QB_DOT_F32_F32_U32_F32,
	QB_DOT_F32_F32_U32_F32_SCA = QB_DOT_F32_F32_U32_F32,
	QB_DOT_F32_F32_U32_F32_ELE,
	QB_DOT_F32_F32_U32_F32_MIO,
	QB_LEN_F32_U32_F32,
	QB_LEN_F32_U32_F32_SCA = QB_LEN_F32_U32_F32,
	QB_LEN_F32_U32_F32_ELE,
	QB_LEN_F32_U32_F32_MIO,
	QB_DIS_F32_F32_U32_F32,
	QB_DIS_F32_F32_U32_F32_SCA = QB_DIS_F32_F32_U32_F32,
	QB_DIS_F32_F32_U32_F32_ELE,
	QB_DIS_F32_F32_U32_F32_MIO,
	QB_NORM_F32_U32_F32,
	QB_NORM_F32_U32_F32_MIO,
	QB_FORE_F32_F32_U32_F32,
	QB_FORE_F32_F32_U32_F32_MIO,
	QB_REFL_F32_F32_U32_F32,
	QB_REFL_F32_F32_U32_F32_MIO,
	QB_REFR_F32_F32_U32_U32_F32,
	QB_REFR_F32_F32_U32_U32_F32_MIO,
	QB_CABS_F32_F32,
	QB_CABS_F32_F32_MIO,
	QB_CARG_F32_F32,
	QB_CARG_F32_F32_MIO,
	QB_CMUL_F32_F32_F32,
	QB_CMUL_F32_F32_F32_MIO,
	QB_CDIV_F32_F32_F32,
	QB_CDIV_F32_F32_F32_MIO,
	QB_CEXP_F32_F32,
	QB_CEXP_F32_F32_MIO,
	QB_CLOG_F32_F32,
	QB_CLOG_F32_F32_MIO,
	QB_CSQRT_F32_F32,
	QB_CSQRT_F32_F32_MIO,
	QB_CPOW_F32_F32_F32,
	QB_CPOW_F32_F32_F32_MIO,
	QB_CSIN_F32_F32,
	QB_CSIN_F32_F32_MIO,
	QB_CCOS_F32_F32,
	QB_CCOS_F32_F32_MIO,
	QB_CTAN_F32_F32,
	QB_CTAN_F32_F32_MIO,
	QB_CSINH_F32_F32,
	QB_CSINH_F32_F32_MIO,
	QB_CCOSH_F32_F32,
	QB_CCOSH_F32_F32_MIO,
	QB_CTANH_F32_F32,
	QB_CTANH_F32_F32_MIO,
	QB_IF_EQ_F64_F64,
	QB_IF_EQ_F64_F64_SCA = QB_IF_EQ_F64_F64,
	QB_IF_EQ_F64_F64_ELE,
	QB_IF_NE_F64_F64,
	QB_IF_NE_F64_F64_SCA = QB_IF_NE_F64_F64,
	QB_IF_NE_F64_F64_ELE,
	QB_IF_LT_F64_F64,
	QB_IF_LT_F64_F64_SCA = QB_IF_LT_F64_F64,
	QB_IF_LT_F64_F64_ELE,
	QB_IF_LE_F64_F64,
	QB_IF_LE_F64_F64_SCA = QB_IF_LE_F64_F64,
	QB_IF_LE_F64_F64_ELE,
	QB_SWITCH8_F64_F64,
	QB_SWITCH8_F64_F64_SCA = QB_SWITCH8_F64_F64,
	QB_SWITCH8_F64_F64_ELE,
	QB_SWITCH16_F64_F64,
	QB_SWITCH16_F64_F64_SCA = QB_SWITCH16_F64_F64,
	QB_SWITCH16_F64_F64_ELE,
	QB_SWITCH32_F64_F64,
	QB_SWITCH32_F64_F64_SCA = QB_SWITCH32_F64_F64,
	QB_SWITCH32_F64_F64_ELE,
	QB_SWITCH64_F64_F64,
	QB_SWITCH64_F64_F64_SCA = QB_SWITCH64_F64_F64,
	QB_SWITCH64_F64_F64_ELE,
	QB_SWITCH128_F64_F64,
	QB_SWITCH128_F64_F64_SCA = QB_SWITCH128_F64_F64,
	QB_SWITCH128_F64_F64_ELE,
	QB_SWITCH256_F64_F64,
	QB_SWITCH256_F64_F64_SCA = QB_SWITCH256_F64_F64,
	QB_SWITCH256_F64_F64_ELE,
	QB_SWITCH512_F64_F64,
	QB_SWITCH512_F64_F64_SCA = QB_SWITCH512_F64_F64,
	QB_SWITCH512_F64_F64_ELE,
	QB_SWITCH1024_F64_F64,
	QB_SWITCH1024_F64_F64_SCA = QB_SWITCH1024_F64_F64,
	QB_SWITCH1024_F64_F64_ELE,
	QB_INC_F64,
	QB_INC_F64_SCA = QB_INC_F64,
	QB_INC_F64_ELE,
	QB_INC_F64_MIO,
	QB_DEC_F64,
	QB_DEC_F64_SCA = QB_DEC_F64,
	QB_DEC_F64_ELE,
	QB_DEC_F64_MIO,
	QB_CBOOL_F64_I32_I32,
	QB_CBOOL_F64_I32_I32_SCA = QB_CBOOL_F64_I32_I32,
	QB_CBOOL_F64_I32_I32_ELE,
	QB_MOV_F64_F64,
	QB_MOV_F64_F64_SCA = QB_MOV_F64_F64,
	QB_MOV_F64_F64_ELE,
	QB_MOV_F64_F64_MIO,
	QB_ADD_F64_F64_F64,
	QB_ADD_F64_F64_F64_SCA = QB_ADD_F64_F64_F64,
	QB_ADD_F64_F64_F64_ELE,
	QB_ADD_F64_F64_F64_MIO,
	QB_MUL_F64_F64_F64,
	QB_MUL_F64_F64_F64_SCA = QB_MUL_F64_F64_F64,
	QB_MUL_F64_F64_F64_ELE,
	QB_MUL_F64_F64_F64_MIO,
	QB_MAC_F64_F64_F64_F64,
	QB_MAC_F64_F64_F64_F64_SCA = QB_MAC_F64_F64_F64_F64,
	QB_MAC_F64_F64_F64_F64_ELE,
	QB_MAC_F64_F64_F64_F64_MIO,
	QB_SUB_F64_F64_F64,
	QB_SUB_F64_F64_F64_SCA = QB_SUB_F64_F64_F64,
	QB_SUB_F64_F64_F64_ELE,
	QB_SUB_F64_F64_F64_MIO,
	QB_DIV_F64_F64_F64,
	QB_DIV_F64_F64_F64_SCA = QB_DIV_F64_F64_F64,
	QB_DIV_F64_F64_F64_ELE,
	QB_DIV_F64_F64_F64_MIO,
	QB_MOD_F64_F64_F64,
	QB_MOD_F64_F64_F64_SCA = QB_MOD_F64_F64_F64,
	QB_MOD_F64_F64_F64_ELE,
	QB_MOD_F64_F64_F64_MIO,
	QB_MOD_FLR_F64_F64_F64,
	QB_MOD_FLR_F64_F64_F64_SCA = QB_MOD_FLR_F64_F64_F64,
	QB_MOD_FLR_F64_F64_F64_ELE,
	QB_MOD_FLR_F64_F64_F64_MIO,
	QB_NEG_F64_F64,
	QB_NEG_F64_F64_SCA = QB_NEG_F64_F64,
	QB_NEG_F64_F64_ELE,
	QB_NEG_F64_F64_MIO,
	QB_EQ_F64_F64_I32,
	QB_EQ_F64_F64_I32_SCA = QB_EQ_F64_F64_I32,
	QB_EQ_F64_F64_I32_ELE,
	QB_EQ_F64_F64_I32_MIO,
	QB_NE_F64_F64_I32,
	QB_NE_F64_F64_I32_SCA = QB_NE_F64_F64_I32,
	QB_NE_F64_F64_I32_ELE,
	QB_NE_F64_F64_I32_MIO,
	QB_LT_F64_F64_I32,
	QB_LT_F64_F64_I32_SCA = QB_LT_F64_F64_I32,
	QB_LT_F64_F64_I32_ELE,
	QB_LT_F64_F64_I32_MIO,
	QB_LE_F64_F64_I32,
	QB_LE_F64_F64_I32_SCA = QB_LE_F64_F64_I32,
	QB_LE_F64_F64_I32_ELE,
	QB_LE_F64_F64_I32_MIO,
	QB_EQ_SET_F64_F64_I32,
	QB_NE_SET_F64_F64_I32,
	QB_LT_SET_F64_F64_I32,
	QB_LE_SET_F64_F64_I32,
	QB_ABS_F64_F64,
	QB_ABS_F64_F64_SCA = QB_ABS_F64_F64,
	QB_ABS_F64_F64_ELE,
	QB_ABS_F64_F64_MIO,
	QB_MIN_F64_F64_F64,
	QB_MIN_F64_F64_F64_SCA = QB_MIN_F64_F64_F64,
	QB_MIN_F64_F64_F64_ELE,
	QB_MIN_F64_F64_F64_MIO,
	QB_MAX_F64_F64_F64,
	QB_MAX_F64_F64_F64_SCA = QB_MAX_F64_F64_F64,
	QB_MAX_F64_F64_F64_ELE,
	QB_MAX_F64_F64_F64_MIO,
	QB_SIN_F64_F64,
	QB_SIN_F64_F64_SCA = QB_SIN_F64_F64,
	QB_SIN_F64_F64_ELE,
	QB_SIN_F64_F64_MIO,
	QB_ASIN_F64_F64,
	QB_ASIN_F64_F64_SCA = QB_ASIN_F64_F64,
	QB_ASIN_F64_F64_ELE,
	QB_ASIN_F64_F64_MIO,
	QB_COS_F64_F64,
	QB_COS_F64_F64_SCA = QB_COS_F64_F64,
	QB_COS_F64_F64_ELE,
	QB_COS_F64_F64_MIO,
	QB_ACOS_F64_F64,
	QB_ACOS_F64_F64_SCA = QB_ACOS_F64_F64,
	QB_ACOS_F64_F64_ELE,
	QB_ACOS_F64_F64_MIO,
	QB_TAN_F64_F64,
	QB_TAN_F64_F64_SCA = QB_TAN_F64_F64,
	QB_TAN_F64_F64_ELE,
	QB_TAN_F64_F64_MIO,
	QB_ATAN_F64_F64,
	QB_ATAN_F64_F64_SCA = QB_ATAN_F64_F64,
	QB_ATAN_F64_F64_ELE,
	QB_ATAN_F64_F64_MIO,
	QB_ATAN2_F64_F64_F64,
	QB_ATAN2_F64_F64_F64_SCA = QB_ATAN2_F64_F64_F64,
	QB_ATAN2_F64_F64_F64_ELE,
	QB_ATAN2_F64_F64_F64_MIO,
	QB_SINH_F64_F64,
	QB_SINH_F64_F64_SCA = QB_SINH_F64_F64,
	QB_SINH_F64_F64_ELE,
	QB_SINH_F64_F64_MIO,
	QB_ASINH_F64_F64,
	QB_ASINH_F64_F64_SCA = QB_ASINH_F64_F64,
	QB_ASINH_F64_F64_ELE,
	QB_ASINH_F64_F64_MIO,
	QB_COSH_F64_F64,
	QB_COSH_F64_F64_SCA = QB_COSH_F64_F64,
	QB_COSH_F64_F64_ELE,
	QB_COSH_F64_F64_MIO,
	QB_ACOSH_F64_F64,
	QB_ACOSH_F64_F64_SCA = QB_ACOSH_F64_F64,
	QB_ACOSH_F64_F64_ELE,
	QB_ACOSH_F64_F64_MIO,
	QB_TANH_F64_F64,
	QB_TANH_F64_F64_SCA = QB_TANH_F64_F64,
	QB_TANH_F64_F64_ELE,
	QB_TANH_F64_F64_MIO,
	QB_ATANH_F64_F64,
	QB_ATANH_F64_F64_SCA = QB_ATANH_F64_F64,
	QB_ATANH_F64_F64_ELE,
	QB_ATANH_F64_F64_MIO,
	QB_CEIL_F64_F64,
	QB_CEIL_F64_F64_SCA = QB_CEIL_F64_F64,
	QB_CEIL_F64_F64_ELE,
	QB_CEIL_F64_F64_MIO,
	QB_FLOOR_F64_F64,
	QB_FLOOR_F64_F64_SCA = QB_FLOOR_F64_F64,
	QB_FLOOR_F64_F64_ELE,
	QB_FLOOR_F64_F64_MIO,
	QB_RINT_F64_F64,
	QB_RINT_F64_F64_SCA = QB_RINT_F64_F64,
	QB_RINT_F64_F64_ELE,
	QB_RINT_F64_F64_MIO,
	QB_ROUND_F64_F64,
	QB_ROUND_F64_F64_SCA = QB_ROUND_F64_F64,
	QB_ROUND_F64_F64_ELE,
	QB_ROUND_F64_F64_MIO,
	QB_LOG_F64_F64,
	QB_LOG_F64_F64_SCA = QB_LOG_F64_F64,
	QB_LOG_F64_F64_ELE,
	QB_LOG_F64_F64_MIO,
	QB_LOG1P_F64_F64,
	QB_LOG1P_F64_F64_SCA = QB_LOG1P_F64_F64,
	QB_LOG1P_F64_F64_ELE,
	QB_LOG1P_F64_F64_MIO,
	QB_LOG2_F64_F64,
	QB_LOG2_F64_F64_SCA = QB_LOG2_F64_F64,
	QB_LOG2_F64_F64_ELE,
	QB_LOG2_F64_F64_MIO,
	QB_LOG10_F64_F64,
	QB_LOG10_F64_F64_SCA = QB_LOG10_F64_F64,
	QB_LOG10_F64_F64_ELE,
	QB_LOG10_F64_F64_MIO,
	QB_EXP_F64_F64,
	QB_EXP_F64_F64_SCA = QB_EXP_F64_F64,
	QB_EXP_F64_F64_ELE,
	QB_EXP_F64_F64_MIO,
	QB_EXPM1_F64_F64,
	QB_EXPM1_F64_F64_SCA = QB_EXPM1_F64_F64,
	QB_EXPM1_F64_F64_ELE,
	QB_EXPM1_F64_F64_MIO,
	QB_EXP2_F64_F64,
	QB_EXP2_F64_F64_SCA = QB_EXP2_F64_F64,
	QB_EXP2_F64_F64_ELE,
	QB_EXP2_F64_F64_MIO,
	QB_POW_F64_F64_F64,
	QB_POW_F64_F64_F64_SCA = QB_POW_F64_F64_F64,
	QB_POW_F64_F64_F64_ELE,
	QB_POW_F64_F64_F64_MIO,
	QB_SQRT_F64_F64,
	QB_SQRT_F64_F64_SCA = QB_SQRT_F64_F64,
	QB_SQRT_F64_F64_ELE,
	QB_SQRT_F64_F64_MIO,
	QB_HYPOT_F64_F64_F64,
	QB_HYPOT_F64_F64_F64_SCA = QB_HYPOT_F64_F64_F64,
	QB_HYPOT_F64_F64_F64_ELE,
	QB_HYPOT_F64_F64_F64_MIO,
	QB_LCG_F64,
	QB_LCG_F64_SCA = QB_LCG_F64,
	QB_LCG_F64_ELE,
	QB_LCG_F64_MIO,
	QB_FIN_F64_I32,
	QB_FIN_F64_I32_SCA = QB_FIN_F64_I32,
	QB_FIN_F64_I32_ELE,
	QB_FIN_F64_I32_MIO,
	QB_INF_F64_I32,
	QB_INF_F64_I32_SCA = QB_INF_F64_I32,
	QB_INF_F64_I32_ELE,
	QB_INF_F64_I32_MIO,
	QB_NAN_F64_I32,
	QB_NAN_F64_I32_SCA = QB_NAN_F64_I32,
	QB_NAN_F64_I32_ELE,
	QB_NAN_F64_I32_MIO,
	QB_RSQRT_F64_F64,
	QB_RSQRT_F64_F64_SCA = QB_RSQRT_F64_F64,
	QB_RSQRT_F64_F64_ELE,
	QB_RSQRT_F64_F64_MIO,
	QB_CLAMP_F64_F64_F64_F64,
	QB_CLAMP_F64_F64_F64_F64_SCA = QB_CLAMP_F64_F64_F64_F64,
	QB_CLAMP_F64_F64_F64_F64_ELE,
	QB_CLAMP_F64_F64_F64_F64_MIO,
	QB_FRACT_F64_F64,
	QB_FRACT_F64_F64_SCA = QB_FRACT_F64_F64,
	QB_FRACT_F64_F64_ELE,
	QB_FRACT_F64_F64_MIO,
	QB_MIX_F64_F64_F64_F64,
	QB_MIX_F64_F64_F64_F64_SCA = QB_MIX_F64_F64_F64_F64,
	QB_MIX_F64_F64_F64_F64_ELE,
	QB_MIX_F64_F64_F64_F64_MIO,
	QB_SIGN_F64_F64,
	QB_SIGN_F64_F64_SCA = QB_SIGN_F64_F64,
	QB_SIGN_F64_F64_ELE,
	QB_SIGN_F64_F64_MIO,
	QB_STEP_F64_F64_F64,
	QB_STEP_F64_F64_F64_SCA = QB_STEP_F64_F64_F64,
	QB_STEP_F64_F64_F64_ELE,
	QB_STEP_F64_F64_F64_MIO,
	QB_SSTEP_F64_F64_F64_F64,
	QB_SSTEP_F64_F64_F64_F64_SCA = QB_SSTEP_F64_F64_F64_F64,
	QB_SSTEP_F64_F64_F64_F64_ELE,
	QB_SSTEP_F64_F64_F64_F64_MIO,
	QB_RAD2DEG_F64_F64,
	QB_RAD2DEG_F64_F64_SCA = QB_RAD2DEG_F64_F64,
	QB_RAD2DEG_F64_F64_ELE,
	QB_RAD2DEG_F64_F64_MIO,
	QB_DEG2RAD_F64_F64,
	QB_DEG2RAD_F64_F64_SCA = QB_DEG2RAD_F64_F64,
	QB_DEG2RAD_F64_F64_ELE,
	QB_DEG2RAD_F64_F64_MIO,
	QB_ROUND_F64_I32_I32_F64,
	QB_ROUND_F64_I32_I32_F64_SCA = QB_ROUND_F64_I32_I32_F64,
	QB_ROUND_F64_I32_I32_F64_ELE,
	QB_ROUND_F64_I32_I32_F64_MIO,
	QB_SORT_U32_F64,
	QB_RSORT_U32_F64,
	QB_AMIN_F64_F64,
	QB_AMIN_F64_F64_SCA = QB_AMIN_F64_F64,
	QB_AMIN_F64_F64_ELE,
	QB_AMAX_F64_F64,
	QB_AMAX_F64_F64_SCA = QB_AMAX_F64_F64,
	QB_AMAX_F64_F64_ELE,
	QB_APROD_F64_F64,
	QB_APROD_F64_F64_SCA = QB_APROD_F64_F64,
	QB_APROD_F64_F64_ELE,
	QB_ASUM_F64_F64,
	QB_ASUM_F64_F64_SCA = QB_ASUM_F64_F64,
	QB_ASUM_F64_F64_ELE,
	QB_RANGE_F64_F64_F64_F64,
	QB_RANGE_F64_F64_F64_F64_SCA = QB_RANGE_F64_F64_F64_F64,
	QB_RANGE_F64_F64_F64_F64_ELE,
	QB_SZ_RANGE_F64_F64_F64_U32,
	QB_SZ_RANGE_F64_F64_F64_U32_SCA = QB_SZ_RANGE_F64_F64_F64_U32,
	QB_SZ_RANGE_F64_F64_F64_U32_ELE,
	QB_AFIND_F64_F64_I32,
	QB_AFIND_F64_F64_I32_SCA = QB_AFIND_F64_F64_I32,
	QB_AFIND_F64_F64_I32_ELE,
	QB_AFIND_F64_F64_I32_MIO,
	QB_AFILL_U32_F64_F64,
	QB_AFILL_U32_F64_F64_SCA = QB_AFILL_U32_F64_F64,
	QB_AFILL_U32_F64_F64_ELE,
	QB_AFILL_U32_F64_F64_MIO,
	QB_APOS_F64_F64_I32_I32,
	QB_APOS_F64_F64_I32_I32_SCA = QB_APOS_F64_F64_I32_I32,
	QB_APOS_F64_F64_I32_I32_ELE,
	QB_ARPOS_F64_F64_I32_I32,
	QB_ARPOS_F64_F64_I32_I32_SCA = QB_ARPOS_F64_F64_I32_I32,
	QB_ARPOS_F64_F64_I32_I32_ELE,
	QB_AREV_F64_U32_F64,
	QB_AUNIQ_F64_U32_F64,
	QB_SZ_AUNIQ_F64_U32_U32,
	QB_ACOL_F64_U32_U32_U32_F64,
	QB_ADIFF_F64_F64_U32_F64,
	QB_SZ_ADIFF_F64_F64_U32_U32,
	QB_AISECT_F64_F64_U32_F64,
	QB_SZ_AISECT_F64_F64_U32_U32,
	QB_SHUFFLE_U32_F64,
	QB_ASLICE_S32_S32_U32_U32_F64_F64,
	QB_ASLICE_S32_S32_U32_U32_F64_F64_SCA = QB_ASLICE_S32_S32_U32_U32_F64_F64,
	QB_ASLICE_S32_S32_U32_U32_F64_F64_ELE,
	QB_AREPLACE_F64_S32_S32_U32_U32_U32_F64,
	QB_AREPLACE_F64_S32_S32_U32_U32_U32_F64_SCA = QB_AREPLACE_F64_S32_S32_U32_U32_U32_F64,
	QB_AREPLACE_F64_S32_S32_U32_U32_U32_F64_ELE,
	QB_ARESIZE1_U32_U32_U32_U32_F64,
	QB_ARESIZE2_U32_U32_U32_U32_U32_U32_U32_F64,
	QB_ARESIZE3_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_F64,
	QB_ARESIZE4_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_F64,
	QB_ARESIZE5_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_F64,
	QB_ARESIZE6_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_F64,
	QB_ARESIZE7_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_F64,
	QB_ARESIZE8_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_F64,
	QB_APAD_F64_S32_F64_F64,
	QB_SAMPLE_NN_4X_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_NN_4X_F64_U32_U32_F64_F64_F64_SCA = QB_SAMPLE_NN_4X_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_NN_4X_F64_U32_U32_F64_F64_F64_ELE,
	QB_SAMPLE_NN_4X_F64_U32_U32_F64_F64_F64_MIO,
	QB_SAMPLE_NN_3X_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_NN_3X_F64_U32_U32_F64_F64_F64_SCA = QB_SAMPLE_NN_3X_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_NN_3X_F64_U32_U32_F64_F64_F64_ELE,
	QB_SAMPLE_NN_3X_F64_U32_U32_F64_F64_F64_MIO,
	QB_SAMPLE_NN_2X_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_NN_2X_F64_U32_U32_F64_F64_F64_SCA = QB_SAMPLE_NN_2X_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_NN_2X_F64_U32_U32_F64_F64_F64_ELE,
	QB_SAMPLE_NN_2X_F64_U32_U32_F64_F64_F64_MIO,
	QB_SAMPLE_NN_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_NN_F64_U32_U32_F64_F64_F64_SCA = QB_SAMPLE_NN_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_NN_F64_U32_U32_F64_F64_F64_ELE,
	QB_SAMPLE_NN_F64_U32_U32_F64_F64_F64_MIO,
	QB_SAMPLE_BL_4X_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_BL_4X_F64_U32_U32_F64_F64_F64_SCA = QB_SAMPLE_BL_4X_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_BL_4X_F64_U32_U32_F64_F64_F64_ELE,
	QB_SAMPLE_BL_4X_F64_U32_U32_F64_F64_F64_MIO,
	QB_SAMPLE_BL_3X_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_BL_3X_F64_U32_U32_F64_F64_F64_SCA = QB_SAMPLE_BL_3X_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_BL_3X_F64_U32_U32_F64_F64_F64_ELE,
	QB_SAMPLE_BL_3X_F64_U32_U32_F64_F64_F64_MIO,
	QB_SAMPLE_BL_2X_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_BL_2X_F64_U32_U32_F64_F64_F64_SCA = QB_SAMPLE_BL_2X_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_BL_2X_F64_U32_U32_F64_F64_F64_ELE,
	QB_SAMPLE_BL_2X_F64_U32_U32_F64_F64_F64_MIO,
	QB_SAMPLE_BL_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_BL_F64_U32_U32_F64_F64_F64_SCA = QB_SAMPLE_BL_F64_U32_U32_F64_F64_F64,
	QB_SAMPLE_BL_F64_U32_U32_F64_F64_F64_ELE,
	QB_SAMPLE_BL_F64_U32_U32_F64_F64_F64_MIO,
	QB_BLEND_2X_F64_F64_F64,
	QB_BLEND_2X_F64_F64_F64_MIO,
	QB_BLEND_4X_F64_F64_F64,
	QB_BLEND_4X_F64_F64_F64_MIO,
	QB_PREMULT_F64_F64,
	QB_PREMULT_F64_F64_MIO,
	QB_UNPREMULT_F64_F64,
	QB_UNPREMULT_F64_F64_MIO,
	QB_RGB2HSV_3X_F64_F64,
	QB_RGB2HSV_3X_F64_F64_MIO,
	QB_RGB2HSV_4X_F64_F64,
	QB_RGB2HSV_4X_F64_F64_MIO,
	QB_HSV2RGB_3X_F64_F64,
	QB_HSV2RGB_3X_F64_F64_MIO,
	QB_HSV2RGB_4X_F64_F64,
	QB_HSV2RGB_4X_F64_F64_MIO,
	QB_RGB2HSL_3X_F64_F64,
	QB_RGB2HSL_3X_F64_F64_MIO,
	QB_RGB2HSL_4X_F64_F64,
	QB_RGB2HSL_4X_F64_F64_MIO,
	QB_HSL2RGB_3X_F64_F64,
	QB_HSL2RGB_3X_F64_F64_MIO,
	QB_HSL2RGB_4X_F64_F64,
	QB_HSL2RGB_4X_F64_F64_MIO,
	QB_MUL_MM_CM_4X_F64_F64_F64,
	QB_MUL_MM_CM_4X_F64_F64_F64_MIO,
	QB_MUL_MV_CM_4X_F64_F64_F64,
	QB_MUL_MV_CM_4X_F64_F64_F64_MIO,
	QB_MUL_VM_CM_4X_F64_F64_F64,
	QB_MUL_VM_CM_4X_F64_F64_F64_MIO,
	QB_MTRAN_4X_F64_F64,
	QB_MTRAN_4X_F64_F64_MIO,
	QB_MINV_4X_F64_F64,
	QB_MINV_4X_F64_F64_MIO,
	QB_MDET_4X_F64_F64,
	QB_MDET_4X_F64_F64_SCA = QB_MDET_4X_F64_F64,
	QB_MDET_4X_F64_F64_ELE,
	QB_MDET_4X_F64_F64_MIO,
	QB_DOT_4X_F64_F64_F64,
	QB_DOT_4X_F64_F64_F64_SCA = QB_DOT_4X_F64_F64_F64,
	QB_DOT_4X_F64_F64_F64_ELE,
	QB_DOT_4X_F64_F64_F64_MIO,
	QB_LEN_4X_F64_F64,
	QB_LEN_4X_F64_F64_SCA = QB_LEN_4X_F64_F64,
	QB_LEN_4X_F64_F64_ELE,
	QB_LEN_4X_F64_F64_MIO,
	QB_DIS_4X_F64_F64_F64,
	QB_DIS_4X_F64_F64_F64_SCA = QB_DIS_4X_F64_F64_F64,
	QB_DIS_4X_F64_F64_F64_ELE,
	QB_DIS_4X_F64_F64_F64_MIO,
	QB_NORM_4X_F64_F64,
	QB_NORM_4X_F64_F64_MIO,
	QB_CROSS_4X_F64_F64_F64_F64,
	QB_CROSS_4X_F64_F64_F64_F64_MIO,
	QB_FORE_4X_F64_F64_F64,
	QB_FORE_4X_F64_F64_F64_MIO,
	QB_REFL_4X_F64_F64_F64,
	QB_REFL_4X_F64_F64_F64_MIO,
	QB_REFR_4X_F64_F64_F64_F64,
	QB_REFR_4X_F64_F64_F64_F64_MIO,
	QB_TRAN_CM_4X_F64_F64_F64,
	QB_TRAN_CM_4X_F64_F64_F64_MIO,
	QB_TRAN_RM_4X_F64_F64_F64,
	QB_TRAN_RM_4X_F64_F64_F64_MIO,
	QB_MOV_4X_F64_F64,
	QB_MOV_4X_F64_F64_MIO,
	QB_ADD_4X_F64_F64_F64,
	QB_ADD_4X_F64_F64_F64_MIO,
	QB_SUB_4X_F64_F64_F64,
	QB_SUB_4X_F64_F64_F64_MIO,
	QB_MUL_4X_F64_F64_F64,
	QB_MUL_4X_F64_F64_F64_MIO,
	QB_DIV_4X_F64_F64_F64,
	QB_DIV_4X_F64_F64_F64_MIO,
	QB_MOD_4X_F64_F64_F64,
	QB_MOD_4X_F64_F64_F64_MIO,
	QB_NEG_4X_F64_F64,
	QB_NEG_4X_F64_F64_MIO,
	QB_INC_4X_F64,
	QB_INC_4X_F64_MIO,
	QB_DEC_4X_F64,
	QB_DEC_4X_F64_MIO,
	QB_MAC_4X_F64_F64_F64_F64,
	QB_MAC_4X_F64_F64_F64_F64_MIO,
	QB_MUL_MM_CM_3X_F64_F64_F64,
	QB_MUL_MM_CM_3X_F64_F64_F64_MIO,
	QB_MUL_MV_CM_3X_F64_F64_F64,
	QB_MUL_MV_CM_3X_F64_F64_F64_MIO,
	QB_MUL_VM_CM_3X_F64_F64_F64,
	QB_MUL_VM_CM_3X_F64_F64_F64_MIO,
	QB_MTRAN_3X_F64_F64,
	QB_MTRAN_3X_F64_F64_MIO,
	QB_MINV_3X_F64_F64,
	QB_MINV_3X_F64_F64_MIO,
	QB_MDET_3X_F64_F64,
	QB_MDET_3X_F64_F64_SCA = QB_MDET_3X_F64_F64,
	QB_MDET_3X_F64_F64_ELE,
	QB_MDET_3X_F64_F64_MIO,
	QB_DOT_3X_F64_F64_F64,
	QB_DOT_3X_F64_F64_F64_SCA = QB_DOT_3X_F64_F64_F64,
	QB_DOT_3X_F64_F64_F64_ELE,
	QB_DOT_3X_F64_F64_F64_MIO,
	QB_LEN_3X_F64_F64,
	QB_LEN_3X_F64_F64_SCA = QB_LEN_3X_F64_F64,
	QB_LEN_3X_F64_F64_ELE,
	QB_LEN_3X_F64_F64_MIO,
	QB_DIS_3X_F64_F64_F64,
	QB_DIS_3X_F64_F64_F64_SCA = QB_DIS_3X_F64_F64_F64,
	QB_DIS_3X_F64_F64_F64_ELE,
	QB_DIS_3X_F64_F64_F64_MIO,
	QB_NORM_3X_F64_F64,
	QB_NORM_3X_F64_F64_MIO,
	QB_CROSS_3X_F64_F64_F64,
	QB_CROSS_3X_F64_F64_F64_MIO,
	QB_FORE_3X_F64_F64_F64,
	QB_FORE_3X_F64_F64_F64_MIO,
	QB_REFL_3X_F64_F64_F64,
	QB_REFL_3X_F64_F64_F64_MIO,
	QB_REFR_3X_F64_F64_F64_F64,
	QB_REFR_3X_F64_F64_F64_F64_MIO,
	QB_TRAN_CM_3X_F64_F64_F64,
	QB_TRAN_CM_3X_F64_F64_F64_MIO,
	QB_TRAN_RM_3X_F64_F64_F64,
	QB_TRAN_RM_3X_F64_F64_F64_MIO,
	QB_MOV_3X_F64_F64,
	QB_MOV_3X_F64_F64_MIO,
	QB_ADD_3X_F64_F64_F64,
	QB_ADD_3X_F64_F64_F64_MIO,
	QB_SUB_3X_F64_F64_F64,
	QB_SUB_3X_F64_F64_F64_MIO,
	QB_MUL_3X_F64_F64_F64,
	QB_MUL_3X_F64_F64_F64_MIO,
	QB_DIV_3X_F64_F64_F64,
	QB_DIV_3X_F64_F64_F64_MIO,
	QB_MOD_3X_F64_F64_F64,
	QB_MOD_3X_F64_F64_F64_MIO,
	QB_NEG_3X_F64_F64,
	QB_NEG_3X_F64_F64_MIO,
	QB_INC_3X_F64,
	QB_INC_3X_F64_MIO,
	QB_DEC_3X_F64,
	QB_DEC_3X_F64_MIO,
	QB_MAC_3X_F64_F64_F64_F64,
	QB_MAC_3X_F64_F64_F64_F64_MIO,
	QB_MUL_MM_CM_2X_F64_F64_F64,
	QB_MUL_MM_CM_2X_F64_F64_F64_MIO,
	QB_MUL_MV_CM_2X_F64_F64_F64,
	QB_MUL_MV_CM_2X_F64_F64_F64_MIO,
	QB_MUL_VM_CM_2X_F64_F64_F64,
	QB_MUL_VM_CM_2X_F64_F64_F64_MIO,
	QB_MTRAN_2X_F64_F64,
	QB_MTRAN_2X_F64_F64_MIO,
	QB_MINV_2X_F64_F64,
	QB_MINV_2X_F64_F64_MIO,
	QB_MDET_2X_F64_F64,
	QB_MDET_2X_F64_F64_SCA = QB_MDET_2X_F64_F64,
	QB_MDET_2X_F64_F64_ELE,
	QB_MDET_2X_F64_F64_MIO,
	QB_DOT_2X_F64_F64_F64,
	QB_DOT_2X_F64_F64_F64_SCA = QB_DOT_2X_F64_F64_F64,
	QB_DOT_2X_F64_F64_F64_ELE,
	QB_DOT_2X_F64_F64_F64_MIO,
	QB_LEN_2X_F64_F64,
	QB_LEN_2X_F64_F64_SCA = QB_LEN_2X_F64_F64,
	QB_LEN_2X_F64_F64_ELE,
	QB_LEN_2X_F64_F64_MIO,
	QB_DIS_2X_F64_F64_F64,
	QB_DIS_2X_F64_F64_F64_SCA = QB_DIS_2X_F64_F64_F64,
	QB_DIS_2X_F64_F64_F64_ELE,
	QB_DIS_2X_F64_F64_F64_MIO,
	QB_NORM_2X_F64_F64,
	QB_NORM_2X_F64_F64_MIO,
	QB_CROSS_2X_F64_F64_F64,
	QB_CROSS_2X_F64_F64_F64_MIO,
	QB_FORE_2X_F64_F64_F64,
	QB_FORE_2X_F64_F64_F64_MIO,
	QB_REFL_2X_F64_F64_F64,
	QB_REFL_2X_F64_F64_F64_MIO,
	QB_REFR_2X_F64_F64_F64_F64,
	QB_REFR_2X_F64_F64_F64_F64_MIO,
	QB_TRAN_CM_2X_F64_F64_F64,
	QB_TRAN_CM_2X_F64_F64_F64_MIO,
	QB_TRAN_RM_2X_F64_F64_F64,
	QB_TRAN_RM_2X_F64_F64_F64_MIO,
	QB_MOV_2X_F64_F64,
	QB_MOV_2X_F64_F64_MIO,
	QB_ADD_2X_F64_F64_F64,
	QB_ADD_2X_F64_F64_F64_MIO,
	QB_SUB_2X_F64_F64_F64,
	QB_SUB_2X_F64_F64_F64_MIO,
	QB_MUL_2X_F64_F64_F64,
	QB_MUL_2X_F64_F64_F64_MIO,
	QB_DIV_2X_F64_F64_F64,
	QB_DIV_2X_F64_F64_F64_MIO,
	QB_MOD_2X_F64_F64_F64,
	QB_MOD_2X_F64_F64_F64_MIO,
	QB_NEG_2X_F64_F64,
	QB_NEG_2X_F64_F64_MIO,
	QB_INC_2X_F64,
	QB_INC_2X_F64_MIO,
	QB_DEC_2X_F64,
	QB_DEC_2X_F64_MIO,
	QB_MAC_2X_F64_F64_F64_F64,
	QB_MAC_2X_F64_F64_F64_F64_MIO,
	QB_MUL_MM_CM_F64_F64_U32_U32_U32_F64,
	QB_MUL_MM_CM_F64_F64_U32_U32_U32_F64_MIO,
	QB_MUL_MV_CM_F64_F64_U32_U32_F64,
	QB_MUL_MV_CM_F64_F64_U32_U32_F64_MIO,
	QB_MUL_VM_CM_F64_F64_U32_U32_F64,
	QB_MUL_VM_CM_F64_F64_U32_U32_F64_MIO,
	QB_MTRAN_F64_U32_U32_F64,
	QB_MTRAN_F64_U32_U32_F64_MIO,
	QB_MINV_F64_U32_F64,
	QB_MINV_F64_U32_F64_MIO,
	QB_MDET_F64_U32_F64,
	QB_MDET_F64_U32_F64_SCA = QB_MDET_F64_U32_F64,
	QB_MDET_F64_U32_F64_ELE,
	QB_MDET_F64_U32_F64_MIO,
	QB_DOT_F64_F64_U32_F64,
	QB_DOT_F64_F64_U32_F64_SCA = QB_DOT_F64_F64_U32_F64,
	QB_DOT_F64_F64_U32_F64_ELE,
	QB_DOT_F64_F64_U32_F64_MIO,
	QB_LEN_F64_U32_F64,
	QB_LEN_F64_U32_F64_SCA = QB_LEN_F64_U32_F64,
	QB_LEN_F64_U32_F64_ELE,
	QB_LEN_F64_U32_F64_MIO,
	QB_DIS_F64_F64_U32_F64,
	QB_DIS_F64_F64_U32_F64_SCA = QB_DIS_F64_F64_U32_F64,
	QB_DIS_F64_F64_U32_F64_ELE,
	QB_DIS_F64_F64_U32_F64_MIO,
	QB_NORM_F64_U32_F64,
	QB_NORM_F64_U32_F64_MIO,
	QB_FORE_F64_F64_U32_F64,
	QB_FORE_F64_F64_U32_F64_MIO,
	QB_REFL_F64_F64_U32_F64,
	QB_REFL_F64_F64_U32_F64_MIO,
	QB_REFR_F64_F64_U32_U32_F64,
	QB_REFR_F64_F64_U32_U32_F64_MIO,
	QB_CABS_F64_F64,
	QB_CABS_F64_F64_MIO,
	QB_CARG_F64_F64,
	QB_CARG_F64_F64_MIO,
	QB_CMUL_F64_F64_F64,
	QB_CMUL_F64_F64_F64_MIO,
	QB_CDIV_F64_F64_F64,
	QB_CDIV_F64_F64_F64_MIO,
	QB_CEXP_F64_F64,
	QB_CEXP_F64_F64_MIO,
	QB_CLOG_F64_F64,
	QB_CLOG_F64_F64_MIO,
	QB_CSQRT_F64_F64,
	QB_CSQRT_F64_F64_MIO,
	QB_CPOW_F64_F64_F64,
	QB_CPOW_F64_F64_F64_MIO,
	QB_CSIN_F64_F64,
	QB_CSIN_F64_F64_MIO,
	QB_CCOS_F64_F64,
	QB_CCOS_F64_F64_MIO,
	QB_CTAN_F64_F64,
	QB_CTAN_F64_F64_MIO,
	QB_CSINH_F64_F64,
	QB_CSINH_F64_F64_MIO,
	QB_CCOSH_F64_F64,
	QB_CCOSH_F64_F64_MIO,
	QB_CTANH_F64_F64,
	QB_CTANH_F64_F64_MIO,
	QB_IF_EQ_I08_I08,
	QB_IF_EQ_I08_I08_SCA = QB_IF_EQ_I08_I08,
	QB_IF_EQ_I08_I08_ELE,
	QB_IF_NE_I08_I08,
	QB_IF_NE_I08_I08_SCA = QB_IF_NE_I08_I08,
	QB_IF_NE_I08_I08_ELE,
	QB_IF_LT_S08_S08,
	QB_IF_LT_S08_S08_SCA = QB_IF_LT_S08_S08,
	QB_IF_LT_S08_S08_ELE,
	QB_IF_LE_S08_S08,
	QB_IF_LE_S08_S08_SCA = QB_IF_LE_S08_S08,
	QB_IF_LE_S08_S08_ELE,
	QB_SWITCH8_I08_I08,
	QB_SWITCH8_I08_I08_SCA = QB_SWITCH8_I08_I08,
	QB_SWITCH8_I08_I08_ELE,
	QB_SWITCH16_I08_I08,
	QB_SWITCH16_I08_I08_SCA = QB_SWITCH16_I08_I08,
	QB_SWITCH16_I08_I08_ELE,
	QB_SWITCH32_I08_I08,
	QB_SWITCH32_I08_I08_SCA = QB_SWITCH32_I08_I08,
	QB_SWITCH32_I08_I08_ELE,
	QB_SWITCH64_I08_I08,
	QB_SWITCH64_I08_I08_SCA = QB_SWITCH64_I08_I08,
	QB_SWITCH64_I08_I08_ELE,
	QB_SWITCH128_I08_I08,
	QB_SWITCH128_I08_I08_SCA = QB_SWITCH128_I08_I08,
	QB_SWITCH128_I08_I08_ELE,
	QB_SWITCH256_I08_I08,
	QB_SWITCH256_I08_I08_SCA = QB_SWITCH256_I08_I08,
	QB_SWITCH256_I08_I08_ELE,
	QB_SWITCH512_I08_I08,
	QB_SWITCH512_I08_I08_SCA = QB_SWITCH512_I08_I08,
	QB_SWITCH512_I08_I08_ELE,
	QB_SWITCH1024_I08_I08,
	QB_SWITCH1024_I08_I08_SCA = QB_SWITCH1024_I08_I08,
	QB_SWITCH1024_I08_I08_ELE,
	QB_INC_I08,
	QB_INC_I08_SCA = QB_INC_I08,
	QB_INC_I08_ELE,
	QB_INC_I08_MIO,
	QB_DEC_I08,
	QB_DEC_I08_SCA = QB_DEC_I08,
	QB_DEC_I08_ELE,
	QB_DEC_I08_MIO,
	QB_CBOOL_I08_I32_I32,
	QB_CBOOL_I08_I32_I32_SCA = QB_CBOOL_I08_I32_I32,
	QB_CBOOL_I08_I32_I32_ELE,
	QB_MOV_I08_I08,
	QB_MOV_I08_I08_SCA = QB_MOV_I08_I08,
	QB_MOV_I08_I08_ELE,
	QB_MOV_I08_I08_MIO,
	QB_ADD_I08_I08_I08,
	QB_ADD_I08_I08_I08_SCA = QB_ADD_I08_I08_I08,
	QB_ADD_I08_I08_I08_ELE,
	QB_ADD_I08_I08_I08_MIO,
	QB_MUL_S08_S08_S08,
	QB_MUL_S08_S08_S08_SCA = QB_MUL_S08_S08_S08,
	QB_MUL_S08_S08_S08_ELE,
	QB_MUL_S08_S08_S08_MIO,
	QB_SUB_I08_I08_I08,
	QB_SUB_I08_I08_I08_SCA = QB_SUB_I08_I08_I08,
	QB_SUB_I08_I08_I08_ELE,
	QB_SUB_I08_I08_I08_MIO,
	QB_DIV_S08_S08_S08,
	QB_DIV_S08_S08_S08_SCA = QB_DIV_S08_S08_S08,
	QB_DIV_S08_S08_S08_ELE,
	QB_DIV_S08_S08_S08_MIO,
	QB_MOD_S08_S08_S08,
	QB_MOD_S08_S08_S08_SCA = QB_MOD_S08_S08_S08,
	QB_MOD_S08_S08_S08_ELE,
	QB_MOD_S08_S08_S08_MIO,
	QB_NEG_I08_I08,
	QB_NEG_I08_I08_SCA = QB_NEG_I08_I08,
	QB_NEG_I08_I08_ELE,
	QB_NEG_I08_I08_MIO,
	QB_BW_AND_I08_I08_I08,
	QB_BW_AND_I08_I08_I08_SCA = QB_BW_AND_I08_I08_I08,
	QB_BW_AND_I08_I08_I08_ELE,
	QB_BW_AND_I08_I08_I08_MIO,
	QB_BW_OR_I08_I08_I08,
	QB_BW_OR_I08_I08_I08_SCA = QB_BW_OR_I08_I08_I08,
	QB_BW_OR_I08_I08_I08_ELE,
	QB_BW_OR_I08_I08_I08_MIO,
	QB_BW_XOR_I08_I08_I08,
	QB_BW_XOR_I08_I08_I08_SCA = QB_BW_XOR_I08_I08_I08,
	QB_BW_XOR_I08_I08_I08_ELE,
	QB_BW_XOR_I08_I08_I08_MIO,
	QB_BW_NOT_I08_I08,
	QB_BW_NOT_I08_I08_SCA = QB_BW_NOT_I08_I08,
	QB_BW_NOT_I08_I08_ELE,
	QB_BW_NOT_I08_I08_MIO,
	QB_SHL_S08_S08_S08,
	QB_SHL_S08_S08_S08_SCA = QB_SHL_S08_S08_S08,
	QB_SHL_S08_S08_S08_ELE,
	QB_SHL_S08_S08_S08_MIO,
	QB_SHR_S08_S08_S08,
	QB_SHR_S08_S08_S08_SCA = QB_SHR_S08_S08_S08,
	QB_SHR_S08_S08_S08_ELE,
	QB_SHR_S08_S08_S08_MIO,
	QB_EQ_I08_I08_I32,
	QB_EQ_I08_I08_I32_SCA = QB_EQ_I08_I08_I32,
	QB_EQ_I08_I08_I32_ELE,
	QB_EQ_I08_I08_I32_MIO,
	QB_NE_I08_I08_I32,
	QB_NE_I08_I08_I32_SCA = QB_NE_I08_I08_I32,
	QB_NE_I08_I08_I32_ELE,
	QB_NE_I08_I08_I32_MIO,
	QB_LT_S08_S08_I32,
	QB_LT_S08_S08_I32_SCA = QB_LT_S08_S08_I32,
	QB_LT_S08_S08_I32_ELE,
	QB_LT_S08_S08_I32_MIO,
	QB_LE_S08_S08_I32,
	QB_LE_S08_S08_I32_SCA = QB_LE_S08_S08_I32,
	QB_LE_S08_S08_I32_ELE,
	QB_LE_S08_S08_I32_MIO,
	QB_EQ_SET_I08_I08_I32,
	QB_NE_SET_I08_I08_I32,
	QB_LT_SET_S08_S08_I32,
	QB_LE_SET_S08_S08_I32,
	QB_ABS_S08_S08,
	QB_ABS_S08_S08_SCA = QB_ABS_S08_S08,
	QB_ABS_S08_S08_ELE,
	QB_ABS_S08_S08_MIO,
	QB_MIN_S08_S08_S08,
	QB_MIN_S08_S08_S08_SCA = QB_MIN_S08_S08_S08,
	QB_MIN_S08_S08_S08_ELE,
	QB_MIN_S08_S08_S08_MIO,
	QB_MAX_S08_S08_S08,
	QB_MAX_S08_S08_S08_SCA = QB_MAX_S08_S08_S08,
	QB_MAX_S08_S08_S08_ELE,
	QB_MAX_S08_S08_S08_MIO,
	QB_RAND_S08_S08_S08,
	QB_RAND_S08_S08_S08_SCA = QB_RAND_S08_S08_S08,
	QB_RAND_S08_S08_S08_ELE,
	QB_RAND_S08_S08_S08_MIO,
	QB_MT_RAND_S08_S08_S08,
	QB_MT_RAND_S08_S08_S08_SCA = QB_MT_RAND_S08_S08_S08,
	QB_MT_RAND_S08_S08_S08_ELE,
	QB_MT_RAND_S08_S08_S08_MIO,
	QB_SORT_U32_S08,
	QB_RSORT_U32_S08,
	QB_AMIN_S08_S08,
	QB_AMIN_S08_S08_SCA = QB_AMIN_S08_S08,
	QB_AMIN_S08_S08_ELE,
	QB_AMAX_S08_S08,
	QB_AMAX_S08_S08_SCA = QB_AMAX_S08_S08,
	QB_AMAX_S08_S08_ELE,
	QB_APROD_S08_S08,
	QB_APROD_S08_S08_SCA = QB_APROD_S08_S08,
	QB_APROD_S08_S08_ELE,
	QB_ASUM_S08_S08,
	QB_ASUM_S08_S08_SCA = QB_ASUM_S08_S08,
	QB_ASUM_S08_S08_ELE,
	QB_RANGE_S08_S08_S08_S08,
	QB_RANGE_S08_S08_S08_S08_SCA = QB_RANGE_S08_S08_S08_S08,
	QB_RANGE_S08_S08_S08_S08_ELE,
	QB_SZ_RANGE_S08_S08_S08_U32,
	QB_SZ_RANGE_S08_S08_S08_U32_SCA = QB_SZ_RANGE_S08_S08_S08_U32,
	QB_SZ_RANGE_S08_S08_S08_U32_ELE,
	QB_AFIND_I08_I08_I32,
	QB_AFIND_I08_I08_I32_SCA = QB_AFIND_I08_I08_I32,
	QB_AFIND_I08_I08_I32_ELE,
	QB_AFIND_I08_I08_I32_MIO,
	QB_AFILL_U32_I08_I08,
	QB_AFILL_U32_I08_I08_SCA = QB_AFILL_U32_I08_I08,
	QB_AFILL_U32_I08_I08_ELE,
	QB_AFILL_U32_I08_I08_MIO,
	QB_APOS_I08_I08_I32_I32,
	QB_APOS_I08_I08_I32_I32_SCA = QB_APOS_I08_I08_I32_I32,
	QB_APOS_I08_I08_I32_I32_ELE,
	QB_ARPOS_I08_I08_I32_I32,
	QB_ARPOS_I08_I08_I32_I32_SCA = QB_ARPOS_I08_I08_I32_I32,
	QB_ARPOS_I08_I08_I32_I32_ELE,
	QB_AREV_I08_U32_I08,
	QB_AUNIQ_I08_U32_I08,
	QB_SZ_AUNIQ_I08_U32_U32,
	QB_ACOL_I08_U32_U32_U32_I08,
	QB_ADIFF_I08_I08_U32_I08,
	QB_SZ_ADIFF_I08_I08_U32_U32,
	QB_AISECT_I08_I08_U32_I08,
	QB_SZ_AISECT_I08_I08_U32_U32,
	QB_SHUFFLE_U32_I08,
	QB_ASLICE_S32_S32_U32_U32_I08_I08,
	QB_ASLICE_S32_S32_U32_U32_I08_I08_SCA = QB_ASLICE_S32_S32_U32_U32_I08_I08,
	QB_ASLICE_S32_S32_U32_U32_I08_I08_ELE,
	QB_AREPLACE_I08_S32_S32_U32_U32_U32_I08,
	QB_AREPLACE_I08_S32_S32_U32_U32_U32_I08_SCA = QB_AREPLACE_I08_S32_S32_U32_U32_U32_I08,
	QB_AREPLACE_I08_S32_S32_U32_U32_U32_I08_ELE,
	QB_ARESIZE1_U32_U32_U32_U32_I08,
	QB_ARESIZE2_U32_U32_U32_U32_U32_U32_U32_I08,
	QB_ARESIZE3_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I08,
	QB_ARESIZE4_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I08,
	QB_ARESIZE5_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I08,
	QB_ARESIZE6_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I08,
	QB_ARESIZE7_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I08,
	QB_ARESIZE8_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I08,
	QB_APAD_I08_S32_I08_I08,
	QB_IF_LT_U08_U08,
	QB_IF_LT_U08_U08_SCA = QB_IF_LT_U08_U08,
	QB_IF_LT_U08_U08_ELE,
	QB_IF_LE_U08_U08,
	QB_IF_LE_U08_U08_SCA = QB_IF_LE_U08_U08,
	QB_IF_LE_U08_U08_ELE,
	QB_MUL_U08_U08_U08,
	QB_MUL_U08_U08_U08_SCA = QB_MUL_U08_U08_U08,
	QB_MUL_U08_U08_U08_ELE,
	QB_MUL_U08_U08_U08_MIO,
	QB_DIV_U08_U08_U08,
	QB_DIV_U08_U08_U08_SCA = QB_DIV_U08_U08_U08,
	QB_DIV_U08_U08_U08_ELE,
	QB_DIV_U08_U08_U08_MIO,
	QB_MOD_U08_U08_U08,
	QB_MOD_U08_U08_U08_SCA = QB_MOD_U08_U08_U08,
	QB_MOD_U08_U08_U08_ELE,
	QB_MOD_U08_U08_U08_MIO,
	QB_SHL_U08_U08_U08,
	QB_SHL_U08_U08_U08_SCA = QB_SHL_U08_U08_U08,
	QB_SHL_U08_U08_U08_ELE,
	QB_SHL_U08_U08_U08_MIO,
	QB_SHR_U08_U08_U08,
	QB_SHR_U08_U08_U08_SCA = QB_SHR_U08_U08_U08,
	QB_SHR_U08_U08_U08_ELE,
	QB_SHR_U08_U08_U08_MIO,
	QB_LT_U08_U08_I32,
	QB_LT_U08_U08_I32_SCA = QB_LT_U08_U08_I32,
	QB_LT_U08_U08_I32_ELE,
	QB_LT_U08_U08_I32_MIO,
	QB_LE_U08_U08_I32,
	QB_LE_U08_U08_I32_SCA = QB_LE_U08_U08_I32,
	QB_LE_U08_U08_I32_ELE,
	QB_LE_U08_U08_I32_MIO,
	QB_LT_SET_U08_U08_I32,
	QB_LE_SET_U08_U08_I32,
	QB_MIN_U08_U08_U08,
	QB_MIN_U08_U08_U08_SCA = QB_MIN_U08_U08_U08,
	QB_MIN_U08_U08_U08_ELE,
	QB_MIN_U08_U08_U08_MIO,
	QB_MAX_U08_U08_U08,
	QB_MAX_U08_U08_U08_SCA = QB_MAX_U08_U08_U08,
	QB_MAX_U08_U08_U08_ELE,
	QB_MAX_U08_U08_U08_MIO,
	QB_RAND_U08_U08_U08,
	QB_RAND_U08_U08_U08_SCA = QB_RAND_U08_U08_U08,
	QB_RAND_U08_U08_U08_ELE,
	QB_RAND_U08_U08_U08_MIO,
	QB_MT_RAND_U08_U08_U08,
	QB_MT_RAND_U08_U08_U08_SCA = QB_MT_RAND_U08_U08_U08,
	QB_MT_RAND_U08_U08_U08_ELE,
	QB_MT_RAND_U08_U08_U08_MIO,
	QB_SORT_U32_U08,
	QB_RSORT_U32_U08,
	QB_AMIN_U08_U08,
	QB_AMIN_U08_U08_SCA = QB_AMIN_U08_U08,
	QB_AMIN_U08_U08_ELE,
	QB_AMAX_U08_U08,
	QB_AMAX_U08_U08_SCA = QB_AMAX_U08_U08,
	QB_AMAX_U08_U08_ELE,
	QB_APROD_U08_U08,
	QB_APROD_U08_U08_SCA = QB_APROD_U08_U08,
	QB_APROD_U08_U08_ELE,
	QB_ASUM_U08_U08,
	QB_ASUM_U08_U08_SCA = QB_ASUM_U08_U08,
	QB_ASUM_U08_U08_ELE,
	QB_RANGE_U08_U08_S08_U08,
	QB_RANGE_U08_U08_S08_U08_SCA = QB_RANGE_U08_U08_S08_U08,
	QB_RANGE_U08_U08_S08_U08_ELE,
	QB_SZ_RANGE_U08_U08_S08_U32,
	QB_SZ_RANGE_U08_U08_S08_U32_SCA = QB_SZ_RANGE_U08_U08_S08_U32,
	QB_SZ_RANGE_U08_U08_S08_U32_ELE,
	QB_IF_EQ_I16_I16,
	QB_IF_EQ_I16_I16_SCA = QB_IF_EQ_I16_I16,
	QB_IF_EQ_I16_I16_ELE,
	QB_IF_NE_I16_I16,
	QB_IF_NE_I16_I16_SCA = QB_IF_NE_I16_I16,
	QB_IF_NE_I16_I16_ELE,
	QB_IF_LT_S16_S16,
	QB_IF_LT_S16_S16_SCA = QB_IF_LT_S16_S16,
	QB_IF_LT_S16_S16_ELE,
	QB_IF_LE_S16_S16,
	QB_IF_LE_S16_S16_SCA = QB_IF_LE_S16_S16,
	QB_IF_LE_S16_S16_ELE,
	QB_SWITCH8_I16_I16,
	QB_SWITCH8_I16_I16_SCA = QB_SWITCH8_I16_I16,
	QB_SWITCH8_I16_I16_ELE,
	QB_SWITCH16_I16_I16,
	QB_SWITCH16_I16_I16_SCA = QB_SWITCH16_I16_I16,
	QB_SWITCH16_I16_I16_ELE,
	QB_SWITCH32_I16_I16,
	QB_SWITCH32_I16_I16_SCA = QB_SWITCH32_I16_I16,
	QB_SWITCH32_I16_I16_ELE,
	QB_SWITCH64_I16_I16,
	QB_SWITCH64_I16_I16_SCA = QB_SWITCH64_I16_I16,
	QB_SWITCH64_I16_I16_ELE,
	QB_SWITCH128_I16_I16,
	QB_SWITCH128_I16_I16_SCA = QB_SWITCH128_I16_I16,
	QB_SWITCH128_I16_I16_ELE,
	QB_SWITCH256_I16_I16,
	QB_SWITCH256_I16_I16_SCA = QB_SWITCH256_I16_I16,
	QB_SWITCH256_I16_I16_ELE,
	QB_SWITCH512_I16_I16,
	QB_SWITCH512_I16_I16_SCA = QB_SWITCH512_I16_I16,
	QB_SWITCH512_I16_I16_ELE,
	QB_SWITCH1024_I16_I16,
	QB_SWITCH1024_I16_I16_SCA = QB_SWITCH1024_I16_I16,
	QB_SWITCH1024_I16_I16_ELE,
	QB_INC_I16,
	QB_INC_I16_SCA = QB_INC_I16,
	QB_INC_I16_ELE,
	QB_INC_I16_MIO,
	QB_DEC_I16,
	QB_DEC_I16_SCA = QB_DEC_I16,
	QB_DEC_I16_ELE,
	QB_DEC_I16_MIO,
	QB_CBOOL_I16_I32_I32,
	QB_CBOOL_I16_I32_I32_SCA = QB_CBOOL_I16_I32_I32,
	QB_CBOOL_I16_I32_I32_ELE,
	QB_MOV_I16_I16,
	QB_MOV_I16_I16_SCA = QB_MOV_I16_I16,
	QB_MOV_I16_I16_ELE,
	QB_MOV_I16_I16_MIO,
	QB_ADD_I16_I16_I16,
	QB_ADD_I16_I16_I16_SCA = QB_ADD_I16_I16_I16,
	QB_ADD_I16_I16_I16_ELE,
	QB_ADD_I16_I16_I16_MIO,
	QB_MUL_S16_S16_S16,
	QB_MUL_S16_S16_S16_SCA = QB_MUL_S16_S16_S16,
	QB_MUL_S16_S16_S16_ELE,
	QB_MUL_S16_S16_S16_MIO,
	QB_SUB_I16_I16_I16,
	QB_SUB_I16_I16_I16_SCA = QB_SUB_I16_I16_I16,
	QB_SUB_I16_I16_I16_ELE,
	QB_SUB_I16_I16_I16_MIO,
	QB_DIV_S16_S16_S16,
	QB_DIV_S16_S16_S16_SCA = QB_DIV_S16_S16_S16,
	QB_DIV_S16_S16_S16_ELE,
	QB_DIV_S16_S16_S16_MIO,
	QB_MOD_S16_S16_S16,
	QB_MOD_S16_S16_S16_SCA = QB_MOD_S16_S16_S16,
	QB_MOD_S16_S16_S16_ELE,
	QB_MOD_S16_S16_S16_MIO,
	QB_NEG_I16_I16,
	QB_NEG_I16_I16_SCA = QB_NEG_I16_I16,
	QB_NEG_I16_I16_ELE,
	QB_NEG_I16_I16_MIO,
	QB_BW_AND_I16_I16_I16,
	QB_BW_AND_I16_I16_I16_SCA = QB_BW_AND_I16_I16_I16,
	QB_BW_AND_I16_I16_I16_ELE,
	QB_BW_AND_I16_I16_I16_MIO,
	QB_BW_OR_I16_I16_I16,
	QB_BW_OR_I16_I16_I16_SCA = QB_BW_OR_I16_I16_I16,
	QB_BW_OR_I16_I16_I16_ELE,
	QB_BW_OR_I16_I16_I16_MIO,
	QB_BW_XOR_I16_I16_I16,
	QB_BW_XOR_I16_I16_I16_SCA = QB_BW_XOR_I16_I16_I16,
	QB_BW_XOR_I16_I16_I16_ELE,
	QB_BW_XOR_I16_I16_I16_MIO,
	QB_BW_NOT_I16_I16,
	QB_BW_NOT_I16_I16_SCA = QB_BW_NOT_I16_I16,
	QB_BW_NOT_I16_I16_ELE,
	QB_BW_NOT_I16_I16_MIO,
	QB_SHL_S16_S16_S16,
	QB_SHL_S16_S16_S16_SCA = QB_SHL_S16_S16_S16,
	QB_SHL_S16_S16_S16_ELE,
	QB_SHL_S16_S16_S16_MIO,
	QB_SHR_S16_S16_S16,
	QB_SHR_S16_S16_S16_SCA = QB_SHR_S16_S16_S16,
	QB_SHR_S16_S16_S16_ELE,
	QB_SHR_S16_S16_S16_MIO,
	QB_EQ_I16_I16_I32,
	QB_EQ_I16_I16_I32_SCA = QB_EQ_I16_I16_I32,
	QB_EQ_I16_I16_I32_ELE,
	QB_EQ_I16_I16_I32_MIO,
	QB_NE_I16_I16_I32,
	QB_NE_I16_I16_I32_SCA = QB_NE_I16_I16_I32,
	QB_NE_I16_I16_I32_ELE,
	QB_NE_I16_I16_I32_MIO,
	QB_LT_S16_S16_I32,
	QB_LT_S16_S16_I32_SCA = QB_LT_S16_S16_I32,
	QB_LT_S16_S16_I32_ELE,
	QB_LT_S16_S16_I32_MIO,
	QB_LE_S16_S16_I32,
	QB_LE_S16_S16_I32_SCA = QB_LE_S16_S16_I32,
	QB_LE_S16_S16_I32_ELE,
	QB_LE_S16_S16_I32_MIO,
	QB_EQ_SET_I16_I16_I32,
	QB_NE_SET_I16_I16_I32,
	QB_LT_SET_S16_S16_I32,
	QB_LE_SET_S16_S16_I32,
	QB_ABS_S16_S16,
	QB_ABS_S16_S16_SCA = QB_ABS_S16_S16,
	QB_ABS_S16_S16_ELE,
	QB_ABS_S16_S16_MIO,
	QB_MIN_S16_S16_S16,
	QB_MIN_S16_S16_S16_SCA = QB_MIN_S16_S16_S16,
	QB_MIN_S16_S16_S16_ELE,
	QB_MIN_S16_S16_S16_MIO,
	QB_MAX_S16_S16_S16,
	QB_MAX_S16_S16_S16_SCA = QB_MAX_S16_S16_S16,
	QB_MAX_S16_S16_S16_ELE,
	QB_MAX_S16_S16_S16_MIO,
	QB_RAND_S16_S16_S16,
	QB_RAND_S16_S16_S16_SCA = QB_RAND_S16_S16_S16,
	QB_RAND_S16_S16_S16_ELE,
	QB_RAND_S16_S16_S16_MIO,
	QB_MT_RAND_S16_S16_S16,
	QB_MT_RAND_S16_S16_S16_SCA = QB_MT_RAND_S16_S16_S16,
	QB_MT_RAND_S16_S16_S16_ELE,
	QB_MT_RAND_S16_S16_S16_MIO,
	QB_SORT_U32_S16,
	QB_RSORT_U32_S16,
	QB_AMIN_S16_S16,
	QB_AMIN_S16_S16_SCA = QB_AMIN_S16_S16,
	QB_AMIN_S16_S16_ELE,
	QB_AMAX_S16_S16,
	QB_AMAX_S16_S16_SCA = QB_AMAX_S16_S16,
	QB_AMAX_S16_S16_ELE,
	QB_APROD_S16_S16,
	QB_APROD_S16_S16_SCA = QB_APROD_S16_S16,
	QB_APROD_S16_S16_ELE,
	QB_ASUM_S16_S16,
	QB_ASUM_S16_S16_SCA = QB_ASUM_S16_S16,
	QB_ASUM_S16_S16_ELE,
	QB_RANGE_S16_S16_S16_S16,
	QB_RANGE_S16_S16_S16_S16_SCA = QB_RANGE_S16_S16_S16_S16,
	QB_RANGE_S16_S16_S16_S16_ELE,
	QB_SZ_RANGE_S16_S16_S16_U32,
	QB_SZ_RANGE_S16_S16_S16_U32_SCA = QB_SZ_RANGE_S16_S16_S16_U32,
	QB_SZ_RANGE_S16_S16_S16_U32_ELE,
	QB_AFIND_I16_I16_I32,
	QB_AFIND_I16_I16_I32_SCA = QB_AFIND_I16_I16_I32,
	QB_AFIND_I16_I16_I32_ELE,
	QB_AFIND_I16_I16_I32_MIO,
	QB_AFILL_U32_I16_I16,
	QB_AFILL_U32_I16_I16_SCA = QB_AFILL_U32_I16_I16,
	QB_AFILL_U32_I16_I16_ELE,
	QB_AFILL_U32_I16_I16_MIO,
	QB_APOS_I16_I16_I32_I32,
	QB_APOS_I16_I16_I32_I32_SCA = QB_APOS_I16_I16_I32_I32,
	QB_APOS_I16_I16_I32_I32_ELE,
	QB_ARPOS_I16_I16_I32_I32,
	QB_ARPOS_I16_I16_I32_I32_SCA = QB_ARPOS_I16_I16_I32_I32,
	QB_ARPOS_I16_I16_I32_I32_ELE,
	QB_AREV_I16_U32_I16,
	QB_AUNIQ_I16_U32_I16,
	QB_SZ_AUNIQ_I16_U32_U32,
	QB_ACOL_I16_U32_U32_U32_I16,
	QB_ADIFF_I16_I16_U32_I16,
	QB_SZ_ADIFF_I16_I16_U32_U32,
	QB_AISECT_I16_I16_U32_I16,
	QB_SZ_AISECT_I16_I16_U32_U32,
	QB_SHUFFLE_U32_I16,
	QB_ASLICE_S32_S32_U32_U32_I16_I16,
	QB_ASLICE_S32_S32_U32_U32_I16_I16_SCA = QB_ASLICE_S32_S32_U32_U32_I16_I16,
	QB_ASLICE_S32_S32_U32_U32_I16_I16_ELE,
	QB_AREPLACE_I16_S32_S32_U32_U32_U32_I16,
	QB_AREPLACE_I16_S32_S32_U32_U32_U32_I16_SCA = QB_AREPLACE_I16_S32_S32_U32_U32_U32_I16,
	QB_AREPLACE_I16_S32_S32_U32_U32_U32_I16_ELE,
	QB_ARESIZE1_U32_U32_U32_U32_I16,
	QB_ARESIZE2_U32_U32_U32_U32_U32_U32_U32_I16,
	QB_ARESIZE3_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I16,
	QB_ARESIZE4_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I16,
	QB_ARESIZE5_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I16,
	QB_ARESIZE6_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I16,
	QB_ARESIZE7_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I16,
	QB_ARESIZE8_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I16,
	QB_APAD_I16_S32_I16_I16,
	QB_IF_LT_U16_U16,
	QB_IF_LT_U16_U16_SCA = QB_IF_LT_U16_U16,
	QB_IF_LT_U16_U16_ELE,
	QB_IF_LE_U16_U16,
	QB_IF_LE_U16_U16_SCA = QB_IF_LE_U16_U16,
	QB_IF_LE_U16_U16_ELE,
	QB_MUL_U16_U16_U16,
	QB_MUL_U16_U16_U16_SCA = QB_MUL_U16_U16_U16,
	QB_MUL_U16_U16_U16_ELE,
	QB_MUL_U16_U16_U16_MIO,
	QB_DIV_U16_U16_U16,
	QB_DIV_U16_U16_U16_SCA = QB_DIV_U16_U16_U16,
	QB_DIV_U16_U16_U16_ELE,
	QB_DIV_U16_U16_U16_MIO,
	QB_MOD_U16_U16_U16,
	QB_MOD_U16_U16_U16_SCA = QB_MOD_U16_U16_U16,
	QB_MOD_U16_U16_U16_ELE,
	QB_MOD_U16_U16_U16_MIO,
	QB_SHL_U16_U16_U16,
	QB_SHL_U16_U16_U16_SCA = QB_SHL_U16_U16_U16,
	QB_SHL_U16_U16_U16_ELE,
	QB_SHL_U16_U16_U16_MIO,
	QB_SHR_U16_U16_U16,
	QB_SHR_U16_U16_U16_SCA = QB_SHR_U16_U16_U16,
	QB_SHR_U16_U16_U16_ELE,
	QB_SHR_U16_U16_U16_MIO,
	QB_LT_U16_U16_I32,
	QB_LT_U16_U16_I32_SCA = QB_LT_U16_U16_I32,
	QB_LT_U16_U16_I32_ELE,
	QB_LT_U16_U16_I32_MIO,
	QB_LE_U16_U16_I32,
	QB_LE_U16_U16_I32_SCA = QB_LE_U16_U16_I32,
	QB_LE_U16_U16_I32_ELE,
	QB_LE_U16_U16_I32_MIO,
	QB_LT_SET_U16_U16_I32,
	QB_LE_SET_U16_U16_I32,
	QB_MIN_U16_U16_U16,
	QB_MIN_U16_U16_U16_SCA = QB_MIN_U16_U16_U16,
	QB_MIN_U16_U16_U16_ELE,
	QB_MIN_U16_U16_U16_MIO,
	QB_MAX_U16_U16_U16,
	QB_MAX_U16_U16_U16_SCA = QB_MAX_U16_U16_U16,
	QB_MAX_U16_U16_U16_ELE,
	QB_MAX_U16_U16_U16_MIO,
	QB_RAND_U16_U16_U16,
	QB_RAND_U16_U16_U16_SCA = QB_RAND_U16_U16_U16,
	QB_RAND_U16_U16_U16_ELE,
	QB_RAND_U16_U16_U16_MIO,
	QB_MT_RAND_U16_U16_U16,
	QB_MT_RAND_U16_U16_U16_SCA = QB_MT_RAND_U16_U16_U16,
	QB_MT_RAND_U16_U16_U16_ELE,
	QB_MT_RAND_U16_U16_U16_MIO,
	QB_SORT_U32_U16,
	QB_RSORT_U32_U16,
	QB_AMIN_U16_U16,
	QB_AMIN_U16_U16_SCA = QB_AMIN_U16_U16,
	QB_AMIN_U16_U16_ELE,
	QB_AMAX_U16_U16,
	QB_AMAX_U16_U16_SCA = QB_AMAX_U16_U16,
	QB_AMAX_U16_U16_ELE,
	QB_APROD_U16_U16,
	QB_APROD_U16_U16_SCA = QB_APROD_U16_U16,
	QB_APROD_U16_U16_ELE,
	QB_ASUM_U16_U16,
	QB_ASUM_U16_U16_SCA = QB_ASUM_U16_U16,
	QB_ASUM_U16_U16_ELE,
	QB_RANGE_U16_U16_S16_U16,
	QB_RANGE_U16_U16_S16_U16_SCA = QB_RANGE_U16_U16_S16_U16,
	QB_RANGE_U16_U16_S16_U16_ELE,
	QB_SZ_RANGE_U16_U16_S16_U32,
	QB_SZ_RANGE_U16_U16_S16_U32_SCA = QB_SZ_RANGE_U16_U16_S16_U32,
	QB_SZ_RANGE_U16_U16_S16_U32_ELE,
	QB_IF_EQ_I64_I64,
	QB_IF_EQ_I64_I64_SCA = QB_IF_EQ_I64_I64,
	QB_IF_EQ_I64_I64_ELE,
	QB_IF_NE_I64_I64,
	QB_IF_NE_I64_I64_SCA = QB_IF_NE_I64_I64,
	QB_IF_NE_I64_I64_ELE,
	QB_IF_LT_S64_S64,
	QB_IF_LT_S64_S64_SCA = QB_IF_LT_S64_S64,
	QB_IF_LT_S64_S64_ELE,
	QB_IF_LE_S64_S64,
	QB_IF_LE_S64_S64_SCA = QB_IF_LE_S64_S64,
	QB_IF_LE_S64_S64_ELE,
	QB_SWITCH8_I64_I64,
	QB_SWITCH8_I64_I64_SCA = QB_SWITCH8_I64_I64,
	QB_SWITCH8_I64_I64_ELE,
	QB_SWITCH16_I64_I64,
	QB_SWITCH16_I64_I64_SCA = QB_SWITCH16_I64_I64,
	QB_SWITCH16_I64_I64_ELE,
	QB_SWITCH32_I64_I64,
	QB_SWITCH32_I64_I64_SCA = QB_SWITCH32_I64_I64,
	QB_SWITCH32_I64_I64_ELE,
	QB_SWITCH64_I64_I64,
	QB_SWITCH64_I64_I64_SCA = QB_SWITCH64_I64_I64,
	QB_SWITCH64_I64_I64_ELE,
	QB_SWITCH128_I64_I64,
	QB_SWITCH128_I64_I64_SCA = QB_SWITCH128_I64_I64,
	QB_SWITCH128_I64_I64_ELE,
	QB_SWITCH256_I64_I64,
	QB_SWITCH256_I64_I64_SCA = QB_SWITCH256_I64_I64,
	QB_SWITCH256_I64_I64_ELE,
	QB_SWITCH512_I64_I64,
	QB_SWITCH512_I64_I64_SCA = QB_SWITCH512_I64_I64,
	QB_SWITCH512_I64_I64_ELE,
	QB_SWITCH1024_I64_I64,
	QB_SWITCH1024_I64_I64_SCA = QB_SWITCH1024_I64_I64,
	QB_SWITCH1024_I64_I64_ELE,
	QB_INC_I64,
	QB_INC_I64_SCA = QB_INC_I64,
	QB_INC_I64_ELE,
	QB_INC_I64_MIO,
	QB_DEC_I64,
	QB_DEC_I64_SCA = QB_DEC_I64,
	QB_DEC_I64_ELE,
	QB_DEC_I64_MIO,
	QB_CBOOL_I64_I32_I32,
	QB_CBOOL_I64_I32_I32_SCA = QB_CBOOL_I64_I32_I32,
	QB_CBOOL_I64_I32_I32_ELE,
	QB_MOV_I64_I64,
	QB_MOV_I64_I64_SCA = QB_MOV_I64_I64,
	QB_MOV_I64_I64_ELE,
	QB_MOV_I64_I64_MIO,
	QB_ADD_I64_I64_I64,
	QB_ADD_I64_I64_I64_SCA = QB_ADD_I64_I64_I64,
	QB_ADD_I64_I64_I64_ELE,
	QB_ADD_I64_I64_I64_MIO,
	QB_MUL_S64_S64_S64,
	QB_MUL_S64_S64_S64_SCA = QB_MUL_S64_S64_S64,
	QB_MUL_S64_S64_S64_ELE,
	QB_MUL_S64_S64_S64_MIO,
	QB_MAC_S64_S64_S64_S64,
	QB_MAC_S64_S64_S64_S64_SCA = QB_MAC_S64_S64_S64_S64,
	QB_MAC_S64_S64_S64_S64_ELE,
	QB_MAC_S64_S64_S64_S64_MIO,
	QB_SUB_I64_I64_I64,
	QB_SUB_I64_I64_I64_SCA = QB_SUB_I64_I64_I64,
	QB_SUB_I64_I64_I64_ELE,
	QB_SUB_I64_I64_I64_MIO,
	QB_DIV_S64_S64_S64,
	QB_DIV_S64_S64_S64_SCA = QB_DIV_S64_S64_S64,
	QB_DIV_S64_S64_S64_ELE,
	QB_DIV_S64_S64_S64_MIO,
	QB_MOD_S64_S64_S64,
	QB_MOD_S64_S64_S64_SCA = QB_MOD_S64_S64_S64,
	QB_MOD_S64_S64_S64_ELE,
	QB_MOD_S64_S64_S64_MIO,
	QB_NEG_I64_I64,
	QB_NEG_I64_I64_SCA = QB_NEG_I64_I64,
	QB_NEG_I64_I64_ELE,
	QB_NEG_I64_I64_MIO,
	QB_BW_AND_I64_I64_I64,
	QB_BW_AND_I64_I64_I64_SCA = QB_BW_AND_I64_I64_I64,
	QB_BW_AND_I64_I64_I64_ELE,
	QB_BW_AND_I64_I64_I64_MIO,
	QB_BW_OR_I64_I64_I64,
	QB_BW_OR_I64_I64_I64_SCA = QB_BW_OR_I64_I64_I64,
	QB_BW_OR_I64_I64_I64_ELE,
	QB_BW_OR_I64_I64_I64_MIO,
	QB_BW_XOR_I64_I64_I64,
	QB_BW_XOR_I64_I64_I64_SCA = QB_BW_XOR_I64_I64_I64,
	QB_BW_XOR_I64_I64_I64_ELE,
	QB_BW_XOR_I64_I64_I64_MIO,
	QB_BW_NOT_I64_I64,
	QB_BW_NOT_I64_I64_SCA = QB_BW_NOT_I64_I64,
	QB_BW_NOT_I64_I64_ELE,
	QB_BW_NOT_I64_I64_MIO,
	QB_SHL_S64_S64_S64,
	QB_SHL_S64_S64_S64_SCA = QB_SHL_S64_S64_S64,
	QB_SHL_S64_S64_S64_ELE,
	QB_SHL_S64_S64_S64_MIO,
	QB_SHR_S64_S64_S64,
	QB_SHR_S64_S64_S64_SCA = QB_SHR_S64_S64_S64,
	QB_SHR_S64_S64_S64_ELE,
	QB_SHR_S64_S64_S64_MIO,
	QB_EQ_I64_I64_I32,
	QB_EQ_I64_I64_I32_SCA = QB_EQ_I64_I64_I32,
	QB_EQ_I64_I64_I32_ELE,
	QB_EQ_I64_I64_I32_MIO,
	QB_NE_I64_I64_I32,
	QB_NE_I64_I64_I32_SCA = QB_NE_I64_I64_I32,
	QB_NE_I64_I64_I32_ELE,
	QB_NE_I64_I64_I32_MIO,
	QB_LT_S64_S64_I32,
	QB_LT_S64_S64_I32_SCA = QB_LT_S64_S64_I32,
	QB_LT_S64_S64_I32_ELE,
	QB_LT_S64_S64_I32_MIO,
	QB_LE_S64_S64_I32,
	QB_LE_S64_S64_I32_SCA = QB_LE_S64_S64_I32,
	QB_LE_S64_S64_I32_ELE,
	QB_LE_S64_S64_I32_MIO,
	QB_EQ_SET_I64_I64_I32,
	QB_NE_SET_I64_I64_I32,
	QB_LT_SET_S64_S64_I32,
	QB_LE_SET_S64_S64_I32,
	QB_ABS_S64_S64,
	QB_ABS_S64_S64_SCA = QB_ABS_S64_S64,
	QB_ABS_S64_S64_ELE,
	QB_ABS_S64_S64_MIO,
	QB_MIN_S64_S64_S64,
	QB_MIN_S64_S64_S64_SCA = QB_MIN_S64_S64_S64,
	QB_MIN_S64_S64_S64_ELE,
	QB_MIN_S64_S64_S64_MIO,
	QB_MAX_S64_S64_S64,
	QB_MAX_S64_S64_S64_SCA = QB_MAX_S64_S64_S64,
	QB_MAX_S64_S64_S64_ELE,
	QB_MAX_S64_S64_S64_MIO,
	QB_RAND_S64_S64_S64,
	QB_RAND_S64_S64_S64_SCA = QB_RAND_S64_S64_S64,
	QB_RAND_S64_S64_S64_ELE,
	QB_RAND_S64_S64_S64_MIO,
	QB_MT_RAND_S64_S64_S64,
	QB_MT_RAND_S64_S64_S64_SCA = QB_MT_RAND_S64_S64_S64,
	QB_MT_RAND_S64_S64_S64_ELE,
	QB_MT_RAND_S64_S64_S64_MIO,
	QB_SORT_U32_S64,
	QB_RSORT_U32_S64,
	QB_AMIN_S64_S64,
	QB_AMIN_S64_S64_SCA = QB_AMIN_S64_S64,
	QB_AMIN_S64_S64_ELE,
	QB_AMAX_S64_S64,
	QB_AMAX_S64_S64_SCA = QB_AMAX_S64_S64,
	QB_AMAX_S64_S64_ELE,
	QB_APROD_S64_S64,
	QB_APROD_S64_S64_SCA = QB_APROD_S64_S64,
	QB_APROD_S64_S64_ELE,
	QB_ASUM_S64_S64,
	QB_ASUM_S64_S64_SCA = QB_ASUM_S64_S64,
	QB_ASUM_S64_S64_ELE,
	QB_RANGE_S64_S64_S64_S64,
	QB_RANGE_S64_S64_S64_S64_SCA = QB_RANGE_S64_S64_S64_S64,
	QB_RANGE_S64_S64_S64_S64_ELE,
	QB_SZ_RANGE_S64_S64_S64_U32,
	QB_SZ_RANGE_S64_S64_S64_U32_SCA = QB_SZ_RANGE_S64_S64_S64_U32,
	QB_SZ_RANGE_S64_S64_S64_U32_ELE,
	QB_AFIND_I64_I64_I32,
	QB_AFIND_I64_I64_I32_SCA = QB_AFIND_I64_I64_I32,
	QB_AFIND_I64_I64_I32_ELE,
	QB_AFIND_I64_I64_I32_MIO,
	QB_AFILL_U32_I64_I64,
	QB_AFILL_U32_I64_I64_SCA = QB_AFILL_U32_I64_I64,
	QB_AFILL_U32_I64_I64_ELE,
	QB_AFILL_U32_I64_I64_MIO,
	QB_APOS_I64_I64_I32_I32,
	QB_APOS_I64_I64_I32_I32_SCA = QB_APOS_I64_I64_I32_I32,
	QB_APOS_I64_I64_I32_I32_ELE,
	QB_ARPOS_I64_I64_I32_I32,
	QB_ARPOS_I64_I64_I32_I32_SCA = QB_ARPOS_I64_I64_I32_I32,
	QB_ARPOS_I64_I64_I32_I32_ELE,
	QB_AREV_I64_U32_I64,
	QB_AUNIQ_I64_U32_I64,
	QB_SZ_AUNIQ_I64_U32_U32,
	QB_ACOL_I64_U32_U32_U32_I64,
	QB_ADIFF_I64_I64_U32_I64,
	QB_SZ_ADIFF_I64_I64_U32_U32,
	QB_AISECT_I64_I64_U32_I64,
	QB_SZ_AISECT_I64_I64_U32_U32,
	QB_SHUFFLE_U32_I64,
	QB_ASLICE_S32_S32_U32_U32_I64_I64,
	QB_ASLICE_S32_S32_U32_U32_I64_I64_SCA = QB_ASLICE_S32_S32_U32_U32_I64_I64,
	QB_ASLICE_S32_S32_U32_U32_I64_I64_ELE,
	QB_AREPLACE_I64_S32_S32_U32_U32_U32_I64,
	QB_AREPLACE_I64_S32_S32_U32_U32_U32_I64_SCA = QB_AREPLACE_I64_S32_S32_U32_U32_U32_I64,
	QB_AREPLACE_I64_S32_S32_U32_U32_U32_I64_ELE,
	QB_ARESIZE1_U32_U32_U32_U32_I64,
	QB_ARESIZE2_U32_U32_U32_U32_U32_U32_U32_I64,
	QB_ARESIZE3_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I64,
	QB_ARESIZE4_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I64,
	QB_ARESIZE5_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I64,
	QB_ARESIZE6_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I64,
	QB_ARESIZE7_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I64,
	QB_ARESIZE8_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_U32_I64,
	QB_APAD_I64_S32_I64_I64,
	QB_IF_LT_U64_U64,
	QB_IF_LT_U64_U64_SCA = QB_IF_LT_U64_U64,
	QB_IF_LT_U64_U64_ELE,
	QB_IF_LE_U64_U64,
	QB_IF_LE_U64_U64_SCA = QB_IF_LE_U64_U64,
	QB_IF_LE_U64_U64_ELE,
	QB_MUL_U64_U64_U64,
	QB_MUL_U64_U64_U64_SCA = QB_MUL_U64_U64_U64,
	QB_MUL_U64_U64_U64_ELE,
	QB_MUL_U64_U64_U64_MIO,
	QB_MAC_U64_U64_U64_U64,
	QB_MAC_U64_U64_U64_U64_SCA = QB_MAC_U64_U64_U64_U64,
	QB_MAC_U64_U64_U64_U64_ELE,
	QB_MAC_U64_U64_U64_U64_MIO,
	QB_DIV_U64_U64_U64,
	QB_DIV_U64_U64_U64_SCA = QB_DIV_U64_U64_U64,
	QB_DIV_U64_U64_U64_ELE,
	QB_DIV_U64_U64_U64_MIO,
	QB_MOD_U64_U64_U64,
	QB_MOD_U64_U64_U64_SCA = QB_MOD_U64_U64_U64,
	QB_MOD_U64_U64_U64_ELE,
	QB_MOD_U64_U64_U64_MIO,
	QB_SHL_U64_U64_U64,
	QB_SHL_U64_U64_U64_SCA = QB_SHL_U64_U64_U64,
	QB_SHL_U64_U64_U64_ELE,
	QB_SHL_U64_U64_U64_MIO,
	QB_SHR_U64_U64_U64,
	QB_SHR_U64_U64_U64_SCA = QB_SHR_U64_U64_U64,
	QB_SHR_U64_U64_U64_ELE,
	QB_SHR_U64_U64_U64_MIO,
	QB_LT_U64_U64_I32,
	QB_LT_U64_U64_I32_SCA = QB_LT_U64_U64_I32,
	QB_LT_U64_U64_I32_ELE,
	QB_LT_U64_U64_I32_MIO,
	QB_LE_U64_U64_I32,
	QB_LE_U64_U64_I32_SCA = QB_LE_U64_U64_I32,
	QB_LE_U64_U64_I32_ELE,
	QB_LE_U64_U64_I32_MIO,
	QB_LT_SET_U64_U64_I32,
	QB_LE_SET_U64_U64_I32,
	QB_MIN_U64_U64_U64,
	QB_MIN_U64_U64_U64_SCA = QB_MIN_U64_U64_U64,
	QB_MIN_U64_U64_U64_ELE,
	QB_MIN_U64_U64_U64_MIO,
	QB_MAX_U64_U64_U64,
	QB_MAX_U64_U64_U64_SCA = QB_MAX_U64_U64_U64,
	QB_MAX_U64_U64_U64_ELE,
	QB_MAX_U64_U64_U64_MIO,
	QB_RAND_U64_U64_U64,
	QB_RAND_U64_U64_U64_SCA = QB_RAND_U64_U64_U64,
	QB_RAND_U64_U64_U64_ELE,
	QB_RAND_U64_U64_U64_MIO,
	QB_MT_RAND_U64_U64_U64,
	QB_MT_RAND_U64_U64_U64_SCA = QB_MT_RAND_U64_U64_U64,
	QB_MT_RAND_U64_U64_U64_ELE,
	QB_MT_RAND_U64_U64_U64_MIO,
	QB_SORT_U32_U64,
	QB_RSORT_U32_U64,
	QB_AMIN_U64_U64,
	QB_AMIN_U64_U64_SCA = QB_AMIN_U64_U64,
	QB_AMIN_U64_U64_ELE,
	QB_AMAX_U64_U64,
	QB_AMAX_U64_U64_SCA = QB_AMAX_U64_U64,
	QB_AMAX_U64_U64_ELE,
	QB_APROD_U64_U64,
	QB_APROD_U64_U64_SCA = QB_APROD_U64_U64,
	QB_APROD_U64_U64_ELE,
	QB_ASUM_U64_U64,
	QB_ASUM_U64_U64_SCA = QB_ASUM_U64_U64,
	QB_ASUM_U64_U64_ELE,
	QB_RANGE_U64_U64_S64_U64,
	QB_RANGE_U64_U64_S64_U64_SCA = QB_RANGE_U64_U64_S64_U64,
	QB_RANGE_U64_U64_S64_U64_ELE,
	QB_SZ_RANGE_U64_U64_S64_U32,
	QB_SZ_RANGE_U64_U64_S64_U32_SCA = QB_SZ_RANGE_U64_U64_S64_U32,
	QB_SZ_RANGE_U64_U64_S64_U32_ELE,
	QB_MOV_U32_F32,
	QB_MOV_U32_F32_SCA = QB_MOV_U32_F32,
	QB_MOV_U32_F32_ELE,
	QB_MOV_U32_F32_MIO,
	QB_MOV_U32_F64,
	QB_MOV_U32_F64_SCA = QB_MOV_U32_F64,
	QB_MOV_U32_F64_ELE,
	QB_MOV_U32_F64_MIO,
	QB_MOV_U32_I64,
	QB_MOV_U32_I64_SCA = QB_MOV_U32_I64,
	QB_MOV_U32_I64_ELE,
	QB_MOV_U32_I64_MIO,
	QB_UTF8_DEC_U08_U32,
	QB_SZ_UTF8_ENC_U32_U32,
	QB_UTF8_ENC_U32_U08,
	QB_PRN_U32,
	QB_PRN_U32_SCA = QB_PRN_U32,
	QB_PRN_U32_ELE,
	QB_PRN_U32_MIO,
	QB_PRN_DIM_U32_U32,
	QB_APP_VAR_U32_U32_U08,
	QB_APP_VAR_U32_U32_U08_SCA = QB_APP_VAR_U32_U32_U08,
	QB_APP_VAR_U32_U32_U08_ELE,
	QB_APP_VAR_U32_U32_U08_MIO,
	QB_APP_VAR_DIM_U32_U32_U32_U08,
	QB_CONV_STR_U08_U32,
	QB_CONV_STR_U08_U32_SCA = QB_CONV_STR_U08_U32,
	QB_CONV_STR_U08_U32_ELE,
	QB_MOV_S32_F32,
	QB_MOV_S32_F32_SCA = QB_MOV_S32_F32,
	QB_MOV_S32_F32_ELE,
	QB_MOV_S32_F32_MIO,
	QB_MOV_S32_F64,
	QB_MOV_S32_F64_SCA = QB_MOV_S32_F64,
	QB_MOV_S32_F64_ELE,
	QB_MOV_S32_F64_MIO,
	QB_MOV_I32_I08,
	QB_MOV_I32_I08_SCA = QB_MOV_I32_I08,
	QB_MOV_I32_I08_ELE,
	QB_MOV_I32_I08_MIO,
	QB_MOV_I32_I16,
	QB_MOV_I32_I16_SCA = QB_MOV_I32_I16,
	QB_MOV_I32_I16_ELE,
	QB_MOV_I32_I16_MIO,
	QB_MOV_S32_I64,
	QB_MOV_S32_I64_SCA = QB_MOV_S32_I64,
	QB_MOV_S32_I64_ELE,
	QB_MOV_S32_I64_MIO,
	QB_BOOL_I32_I32,
	QB_BOOL_I32_I32_SCA = QB_BOOL_I32_I32,
	QB_BOOL_I32_I32_ELE,
	QB_GATH_2X_U32_I32_I32,
	QB_GATH_3X_U32_I32_I32,
	QB_GATH_4X_U32_I32_I32,
	QB_GATH_5X_U32_I32_I32,
	QB_GATH_6X_U32_I32_I32,
	QB_GATH_7X_U32_I32_I32,
	QB_GATH_8X_U32_I32_I32,
	QB_SCAT_2X_U32_I32_I32,
	QB_SCAT_3X_U32_I32_I32,
	QB_SCAT_4X_U32_I32_I32,
	QB_SCAT_5X_U32_I32_I32,
	QB_SCAT_6X_U32_I32_I32,
	QB_SCAT_7X_U32_I32_I32,
	QB_SCAT_8X_U32_I32_I32,
	QB_CLR_SCA_I32,
	QB_CLR_ARR_RSZ_U32_I32,
	QB_CLR_ARR_RSZ_DIM_U32_U32_I32,
	QB_CLR_ELE_RSZ_U32_U32_U32_I32,
	QB_CLR_ELE_RSZ_DIM_U32_U32_U32_U32_I32,
	QB_CCLR_ARR_I32_I32,
	QB_CCLR_ELE_U32_U32_I32_I32,
	QB_PRN_S32,
	QB_PRN_S32_SCA = QB_PRN_S32,
	QB_PRN_S32_ELE,
	QB_PRN_S32_MIO,
	QB_PRN_DIM_S32_U32,
	QB_APP_VAR_S32_U32_U08,
	QB_APP_VAR_S32_U32_U08_SCA = QB_APP_VAR_S32_U32_U08,
	QB_APP_VAR_S32_U32_U08_ELE,
	QB_APP_VAR_S32_U32_U08_MIO,
	QB_APP_VAR_DIM_S32_U32_U32_U08,
	QB_PACK_LE_I32_U08,
	QB_PACK_LE_I32_U08_SCA = QB_PACK_LE_I32_U08,
	QB_PACK_LE_I32_U08_ELE,
	QB_PACK_BE_I32_U08,
	QB_PACK_BE_I32_U08_SCA = QB_PACK_BE_I32_U08,
	QB_PACK_BE_I32_U08_ELE,
	QB_UNPACK_LE_U08_I32,
	QB_UNPACK_LE_U08_I32_SCA = QB_UNPACK_LE_U08_I32,
	QB_UNPACK_LE_U08_I32_ELE,
	QB_UNPACK_BE_U08_I32,
	QB_UNPACK_BE_U08_I32_SCA = QB_UNPACK_BE_U08_I32,
	QB_UNPACK_BE_U08_I32_ELE,
	QB_CONV_STR_U08_S32,
	QB_CONV_STR_U08_S32_SCA = QB_CONV_STR_U08_S32,
	QB_CONV_STR_U08_S32_ELE,
	QB_MOV_F32_U32,
	QB_MOV_F32_U32_SCA = QB_MOV_F32_U32,
	QB_MOV_F32_U32_ELE,
	QB_MOV_F32_U32_MIO,
	QB_MOV_F32_S32,
	QB_MOV_F32_S32_SCA = QB_MOV_F32_S32,
	QB_MOV_F32_S32_ELE,
	QB_MOV_F32_S32_MIO,
	QB_MOV_F32_F64,
	QB_MOV_F32_F64_SCA = QB_MOV_F32_F64,
	QB_MOV_F32_F64_ELE,
	QB_MOV_F32_F64_MIO,
	QB_MOV_F32_S08,
	QB_MOV_F32_S08_SCA = QB_MOV_F32_S08,
	QB_MOV_F32_S08_ELE,
	QB_MOV_F32_S08_MIO,
	QB_MOV_F32_U08,
	QB_MOV_F32_U08_SCA = QB_MOV_F32_U08,
	QB_MOV_F32_U08_ELE,
	QB_MOV_F32_U08_MIO,
	QB_MOV_F32_S16,
	QB_MOV_F32_S16_SCA = QB_MOV_F32_S16,
	QB_MOV_F32_S16_ELE,
	QB_MOV_F32_S16_MIO,
	QB_MOV_F32_U16,
	QB_MOV_F32_U16_SCA = QB_MOV_F32_U16,
	QB_MOV_F32_U16_ELE,
	QB_MOV_F32_U16_MIO,
	QB_MOV_F32_S64,
	QB_MOV_F32_S64_SCA = QB_MOV_F32_S64,
	QB_MOV_F32_S64_ELE,
	QB_MOV_F32_S64_MIO,
	QB_MOV_F32_U64,
	QB_MOV_F32_U64_SCA = QB_MOV_F32_U64,
	QB_MOV_F32_U64_ELE,
	QB_MOV_F32_U64_MIO,
	QB_BOOL_F32_I32,
	QB_BOOL_F32_I32_SCA = QB_BOOL_F32_I32,
	QB_BOOL_F32_I32_ELE,
	QB_GATH_2X_U32_F32_F32,
	QB_GATH_3X_U32_F32_F32,
	QB_GATH_4X_U32_F32_F32,
	QB_GATH_5X_U32_F32_F32,
	QB_GATH_6X_U32_F32_F32,
	QB_GATH_7X_U32_F32_F32,
	QB_GATH_8X_U32_F32_F32,
	QB_SCAT_2X_U32_F32_F32,
	QB_SCAT_3X_U32_F32_F32,
	QB_SCAT_4X_U32_F32_F32,
	QB_SCAT_5X_U32_F32_F32,
	QB_SCAT_6X_U32_F32_F32,
	QB_SCAT_7X_U32_F32_F32,
	QB_SCAT_8X_U32_F32_F32,
	QB_CLR_SCA_F32,
	QB_CLR_ARR_RSZ_U32_F32,
	QB_CLR_ARR_RSZ_DIM_U32_U32_F32,
	QB_CLR_ELE_RSZ_U32_U32_U32_F32,
	QB_CLR_ELE_RSZ_DIM_U32_U32_U32_U32_F32,
	QB_CCLR_ARR_I32_F32,
	QB_CCLR_ELE_U32_U32_I32_F32,
	QB_PRN_F32,
	QB_PRN_F32_SCA = QB_PRN_F32,
	QB_PRN_F32_ELE,
	QB_PRN_F32_MIO,
	QB_PRN_DIM_F32_U32,
	QB_APP_VAR_F32_U32_U08,
	QB_APP_VAR_F32_U32_U08_SCA = QB_APP_VAR_F32_U32_U08,
	QB_APP_VAR_F32_U32_U08_ELE,
	QB_APP_VAR_F32_U32_U08_MIO,
	QB_APP_VAR_DIM_F32_U32_U32_U08,
	QB_PACK_LE_F32_U08,
	QB_PACK_LE_F32_U08_SCA = QB_PACK_LE_F32_U08,
	QB_PACK_LE_F32_U08_ELE,
	QB_PACK_BE_F32_U08,
	QB_PACK_BE_F32_U08_SCA = QB_PACK_BE_F32_U08,
	QB_PACK_BE_F32_U08_ELE,
	QB_UNPACK_LE_U08_F32,
	QB_UNPACK_LE_U08_F32_SCA = QB_UNPACK_LE_U08_F32,
	QB_UNPACK_LE_U08_F32_ELE,
	QB_UNPACK_BE_U08_F32,
	QB_UNPACK_BE_U08_F32_SCA = QB_UNPACK_BE_U08_F32,
	QB_UNPACK_BE_U08_F32_ELE,
	QB_CONV_STR_U08_F32,
	QB_CONV_STR_U08_F32_SCA = QB_CONV_STR_U08_F32,
	QB_CONV_STR_U08_F32_ELE,
	QB_MOV_F64_U32,
	QB_MOV_F64_U32_SCA = QB_MOV_F64_U32,
	QB_MOV_F64_U32_ELE,
	QB_MOV_F64_U32_MIO,
	QB_MOV_F64_S32,
	QB_MOV_F64_S32_SCA = QB_MOV_F64_S32,
	QB_MOV_F64_S32_ELE,
	QB_MOV_F64_S32_MIO,
	QB_MOV_F64_F32,
	QB_MOV_F64_F32_SCA = QB_MOV_F64_F32,
	QB_MOV_F64_F32_ELE,
	QB_MOV_F64_F32_MIO,
	QB_MOV_F64_S08,
	QB_MOV_F64_S08_SCA = QB_MOV_F64_S08,
	QB_MOV_F64_S08_ELE,
	QB_MOV_F64_S08_MIO,
	QB_MOV_F64_U08,
	QB_MOV_F64_U08_SCA = QB_MOV_F64_U08,
	QB_MOV_F64_U08_ELE,
	QB_MOV_F64_U08_MIO,
	QB_MOV_F64_S16,
	QB_MOV_F64_S16_SCA = QB_MOV_F64_S16,
	QB_MOV_F64_S16_ELE,
	QB_MOV_F64_S16_MIO,
	QB_MOV_F64_U16,
	QB_MOV_F64_U16_SCA = QB_MOV_F64_U16,
	QB_MOV_F64_U16_ELE,
	QB_MOV_F64_U16_MIO,
	QB_MOV_F64_S64,
	QB_MOV_F64_S64_SCA = QB_MOV_F64_S64,
	QB_MOV_F64_S64_ELE,
	QB_MOV_F64_S64_MIO,
	QB_MOV_F64_U64,
	QB_MOV_F64_U64_SCA = QB_MOV_F64_U64,
	QB_MOV_F64_U64_ELE,
	QB_MOV_F64_U64_MIO,
	QB_BOOL_F64_I32,
	QB_BOOL_F64_I32_SCA = QB_BOOL_F64_I32,
	QB_BOOL_F64_I32_ELE,
	QB_GATH_2X_U32_F64_F64,
	QB_GATH_3X_U32_F64_F64,
	QB_GATH_4X_U32_F64_F64,
	QB_GATH_5X_U32_F64_F64,
	QB_GATH_6X_U32_F64_F64,
	QB_GATH_7X_U32_F64_F64,
	QB_GATH_8X_U32_F64_F64,
	QB_SCAT_2X_U32_F64_F64,
	QB_SCAT_3X_U32_F64_F64,
	QB_SCAT_4X_U32_F64_F64,
	QB_SCAT_5X_U32_F64_F64,
	QB_SCAT_6X_U32_F64_F64,
	QB_SCAT_7X_U32_F64_F64,
	QB_SCAT_8X_U32_F64_F64,
	QB_CLR_SCA_F64,
	QB_CLR_ARR_RSZ_U32_F64,
	QB_CLR_ARR_RSZ_DIM_U32_U32_F64,
	QB_CLR_ELE_RSZ_U32_U32_U32_F64,
	QB_CLR_ELE_RSZ_DIM_U32_U32_U32_U32_F64,
	QB_CCLR_ARR_I32_F64,
	QB_CCLR_ELE_U32_U32_I32_F64,
	QB_PRN_F64,
	QB_PRN_F64_SCA = QB_PRN_F64,
	QB_PRN_F64_ELE,
	QB_PRN_F64_MIO,
	QB_PRN_DIM_F64_U32,
	QB_APP_VAR_F64_U32_U08,
	QB_APP_VAR_F64_U32_U08_SCA = QB_APP_VAR_F64_U32_U08,
	QB_APP_VAR_F64_U32_U08_ELE,
	QB_APP_VAR_F64_U32_U08_MIO,
	QB_APP_VAR_DIM_F64_U32_U32_U08,
	QB_PACK_LE_F64_U08,
	QB_PACK_LE_F64_U08_SCA = QB_PACK_LE_F64_U08,
	QB_PACK_LE_F64_U08_ELE,
	QB_PACK_BE_F64_U08,
	QB_PACK_BE_F64_U08_SCA = QB_PACK_BE_F64_U08,
	QB_PACK_BE_F64_U08_ELE,
	QB_UNPACK_LE_U08_F64,
	QB_UNPACK_LE_U08_F64_SCA = QB_UNPACK_LE_U08_F64,
	QB_UNPACK_LE_U08_F64_ELE,
	QB_UNPACK_BE_U08_F64,
	QB_UNPACK_BE_U08_F64_SCA = QB_UNPACK_BE_U08_F64,
	QB_UNPACK_BE_U08_F64_ELE,
	QB_CONV_STR_U08_F64,
	QB_CONV_STR_U08_F64_SCA = QB_CONV_STR_U08_F64,
	QB_CONV_STR_U08_F64_ELE,
	QB_MOV_S08_I32,
	QB_MOV_S08_I32_SCA = QB_MOV_S08_I32,
	QB_MOV_S08_I32_ELE,
	QB_MOV_S08_I32_MIO,
	QB_MOV_S08_F32,
	QB_MOV_S08_F32_SCA = QB_MOV_S08_F32,
	QB_MOV_S08_F32_ELE,
	QB_MOV_S08_F32_MIO,
	QB_MOV_S08_F64,
	QB_MOV_S08_F64_SCA = QB_MOV_S08_F64,
	QB_MOV_S08_F64_ELE,
	QB_MOV_S08_F64_MIO,
	QB_MOV_S08_I16,
	QB_MOV_S08_I16_SCA = QB_MOV_S08_I16,
	QB_MOV_S08_I16_ELE,
	QB_MOV_S08_I16_MIO,
	QB_MOV_S08_I64,
	QB_MOV_S08_I64_SCA = QB_MOV_S08_I64,
	QB_MOV_S08_I64_ELE,
	QB_MOV_S08_I64_MIO,
	QB_BOOL_I08_I32,
	QB_BOOL_I08_I32_SCA = QB_BOOL_I08_I32,
	QB_BOOL_I08_I32_ELE,
	QB_GATH_2X_U32_I08_I08,
	QB_GATH_3X_U32_I08_I08,
	QB_GATH_4X_U32_I08_I08,
	QB_GATH_5X_U32_I08_I08,
	QB_GATH_6X_U32_I08_I08,
	QB_GATH_7X_U32_I08_I08,
	QB_GATH_8X_U32_I08_I08,
	QB_SCAT_2X_U32_I08_I08,
	QB_SCAT_3X_U32_I08_I08,
	QB_SCAT_4X_U32_I08_I08,
	QB_SCAT_5X_U32_I08_I08,
	QB_SCAT_6X_U32_I08_I08,
	QB_SCAT_7X_U32_I08_I08,
	QB_SCAT_8X_U32_I08_I08,
	QB_CLR_SCA_I08,
	QB_CLR_ARR_RSZ_U32_I08,
	QB_CLR_ARR_RSZ_DIM_U32_U32_I08,
	QB_CLR_ELE_RSZ_U32_U32_U32_I08,
	QB_CLR_ELE_RSZ_DIM_U32_U32_U32_U32_I08,
	QB_CCLR_ARR_I32_I08,
	QB_CCLR_ELE_U32_U32_I32_I08,
	QB_PRN_S08,
	QB_PRN_S08_SCA = QB_PRN_S08,
	QB_PRN_S08_ELE,
	QB_PRN_S08_MIO,
	QB_PRN_DIM_S08_U32,
	QB_APP_VAR_S08_U32_U08,
	QB_APP_VAR_S08_U32_U08_SCA = QB_APP_VAR_S08_U32_U08,
	QB_APP_VAR_S08_U32_U08_ELE,
	QB_APP_VAR_S08_U32_U08_MIO,
	QB_APP_VAR_DIM_S08_U32_U32_U08,
	QB_CONV_STR_U08_S08,
	QB_CONV_STR_U08_S08_SCA = QB_CONV_STR_U08_S08,
	QB_CONV_STR_U08_S08_ELE,
	QB_MOV_U08_I32,
	QB_MOV_U08_I32_SCA = QB_MOV_U08_I32,
	QB_MOV_U08_I32_ELE,
	QB_MOV_U08_I32_MIO,
	QB_MOV_U08_F32,
	QB_MOV_U08_F32_SCA = QB_MOV_U08_F32,
	QB_MOV_U08_F32_ELE,
	QB_MOV_U08_F32_MIO,
	QB_MOV_U08_F64,
	QB_MOV_U08_F64_SCA = QB_MOV_U08_F64,
	QB_MOV_U08_F64_ELE,
	QB_MOV_U08_F64_MIO,
	QB_MOV_U08_I16,
	QB_MOV_U08_I16_SCA = QB_MOV_U08_I16,
	QB_MOV_U08_I16_ELE,
	QB_MOV_U08_I16_MIO,
	QB_MOV_U08_I64,
	QB_MOV_U08_I64_SCA = QB_MOV_U08_I64,
	QB_MOV_U08_I64_ELE,
	QB_MOV_U08_I64_MIO,
	QB_PRN_STR_U08,
	QB_APP_STR_U08_U32_U08,
	QB_FLUSH,
	QB_PRN_U08,
	QB_PRN_U08_SCA = QB_PRN_U08,
	QB_PRN_U08_ELE,
	QB_PRN_U08_MIO,
	QB_PRN_DIM_U08_U32,
	QB_APP_VAR_U08_U32_U08,
	QB_APP_VAR_U08_U32_U08_SCA = QB_APP_VAR_U08_U32_U08,
	QB_APP_VAR_U08_U32_U08_ELE,
	QB_APP_VAR_U08_U32_U08_MIO,
	QB_APP_VAR_DIM_U08_U32_U32_U08,
	QB_CONV_STR_U08_U08,
	QB_CONV_STR_U08_U08_SCA = QB_CONV_STR_U08_U08,
	QB_CONV_STR_U08_U08_ELE,
	QB_MOV_S16_I32,
	QB_MOV_S16_I32_SCA = QB_MOV_S16_I32,
	QB_MOV_S16_I32_ELE,
	QB_MOV_S16_I32_MIO,
	QB_MOV_S16_F32,
	QB_MOV_S16_F32_SCA = QB_MOV_S16_F32,
	QB_MOV_S16_F32_ELE,
	QB_MOV_S16_F32_MIO,
	QB_MOV_S16_F64,
	QB_MOV_S16_F64_SCA = QB_MOV_S16_F64,
	QB_MOV_S16_F64_ELE,
	QB_MOV_S16_F64_MIO,
	QB_MOV_I16_I08,
	QB_MOV_I16_I08_SCA = QB_MOV_I16_I08,
	QB_MOV_I16_I08_ELE,
	QB_MOV_I16_I08_MIO,
	QB_MOV_S16_I64,
	QB_MOV_S16_I64_SCA = QB_MOV_S16_I64,
	QB_MOV_S16_I64_ELE,
	QB_MOV_S16_I64_MIO,
	QB_BOOL_I16_I32,
	QB_BOOL_I16_I32_SCA = QB_BOOL_I16_I32,
	QB_BOOL_I16_I32_ELE,
	QB_GATH_2X_U32_I16_I16,
	QB_GATH_3X_U32_I16_I16,
	QB_GATH_4X_U32_I16_I16,
	QB_GATH_5X_U32_I16_I16,
	QB_GATH_6X_U32_I16_I16,
	QB_GATH_7X_U32_I16_I16,
	QB_GATH_8X_U32_I16_I16,
	QB_SCAT_2X_U32_I16_I16,
	QB_SCAT_3X_U32_I16_I16,
	QB_SCAT_4X_U32_I16_I16,
	QB_SCAT_5X_U32_I16_I16,
	QB_SCAT_6X_U32_I16_I16,
	QB_SCAT_7X_U32_I16_I16,
	QB_SCAT_8X_U32_I16_I16,
	QB_CLR_SCA_I16,
	QB_CLR_ARR_RSZ_U32_I16,
	QB_CLR_ARR_RSZ_DIM_U32_U32_I16,
	QB_CLR_ELE_RSZ_U32_U32_U32_I16,
	QB_CLR_ELE_RSZ_DIM_U32_U32_U32_U32_I16,
	QB_CCLR_ARR_I32_I16,
	QB_CCLR_ELE_U32_U32_I32_I16,
	QB_PRN_S16,
	QB_PRN_S16_SCA = QB_PRN_S16,
	QB_PRN_S16_ELE,
	QB_PRN_S16_MIO,
	QB_PRN_DIM_S16_U32,
	QB_APP_VAR_S16_U32_U08,
	QB_APP_VAR_S16_U32_U08_SCA = QB_APP_VAR_S16_U32_U08,
	QB_APP_VAR_S16_U32_U08_ELE,
	QB_APP_VAR_S16_U32_U08_MIO,
	QB_APP_VAR_DIM_S16_U32_U32_U08,
	QB_PACK_LE_I16_U08,
	QB_PACK_LE_I16_U08_SCA = QB_PACK_LE_I16_U08,
	QB_PACK_LE_I16_U08_ELE,
	QB_PACK_BE_I16_U08,
	QB_PACK_BE_I16_U08_SCA = QB_PACK_BE_I16_U08,
	QB_PACK_BE_I16_U08_ELE,
	QB_UNPACK_LE_U08_I16,
	QB_UNPACK_LE_U08_I16_SCA = QB_UNPACK_LE_U08_I16,
	QB_UNPACK_LE_U08_I16_ELE,
	QB_UNPACK_BE_U08_I16,
	QB_UNPACK_BE_U08_I16_SCA = QB_UNPACK_BE_U08_I16,
	QB_UNPACK_BE_U08_I16_ELE,
	QB_CONV_STR_U08_S16,
	QB_CONV_STR_U08_S16_SCA = QB_CONV_STR_U08_S16,
	QB_CONV_STR_U08_S16_ELE,
	QB_MOV_U16_I32,
	QB_MOV_U16_I32_SCA = QB_MOV_U16_I32,
	QB_MOV_U16_I32_ELE,
	QB_MOV_U16_I32_MIO,
	QB_MOV_U16_F32,
	QB_MOV_U16_F32_SCA = QB_MOV_U16_F32,
	QB_MOV_U16_F32_ELE,
	QB_MOV_U16_F32_MIO,
	QB_MOV_U16_F64,
	QB_MOV_U16_F64_SCA = QB_MOV_U16_F64,
	QB_MOV_U16_F64_ELE,
	QB_MOV_U16_F64_MIO,
	QB_MOV_U16_I64,
	QB_MOV_U16_I64_SCA = QB_MOV_U16_I64,
	QB_MOV_U16_I64_ELE,
	QB_MOV_U16_I64_MIO,
	QB_SZ_UTF8_DEC_U08_U32,
	QB_UTF8_DEC_U08_U16,
	QB_SZ_UTF8_ENC_U16_U32,
	QB_UTF8_ENC_U16_U08,
	QB_PRN_U16,
	QB_PRN_U16_SCA = QB_PRN_U16,
	QB_PRN_U16_ELE,
	QB_PRN_U16_MIO,
	QB_PRN_DIM_U16_U32,
	QB_APP_VAR_U16_U32_U08,
	QB_APP_VAR_U16_U32_U08_SCA = QB_APP_VAR_U16_U32_U08,
	QB_APP_VAR_U16_U32_U08_ELE,
	QB_APP_VAR_U16_U32_U08_MIO,
	QB_APP_VAR_DIM_U16_U32_U32_U08,
	QB_CONV_STR_U08_U16,
	QB_CONV_STR_U08_U16_SCA = QB_CONV_STR_U08_U16,
	QB_CONV_STR_U08_U16_ELE,
	QB_MOV_I64_I32,
	QB_MOV_I64_I32_SCA = QB_MOV_I64_I32,
	QB_MOV_I64_I32_ELE,
	QB_MOV_I64_I32_MIO,
	QB_MOV_S64_F32,
	QB_MOV_S64_F32_SCA = QB_MOV_S64_F32,
	QB_MOV_S64_F32_ELE,
	QB_MOV_S64_F32_MIO,
	QB_MOV_S64_F64,
	QB_MOV_S64_F64_SCA = QB_MOV_S64_F64,
	QB_MOV_S64_F64_ELE,
	QB_MOV_S64_F64_MIO,
	QB_MOV_I64_I08,
	QB_MOV_I64_I08_SCA = QB_MOV_I64_I08,
	QB_MOV_I64_I08_ELE,
	QB_MOV_I64_I08_MIO,
	QB_MOV_I64_I16,
	QB_MOV_I64_I16_SCA = QB_MOV_I64_I16,
	QB_MOV_I64_I16_ELE,
	QB_MOV_I64_I16_MIO,
	QB_BOOL_I64_I32,
	QB_BOOL_I64_I32_SCA = QB_BOOL_I64_I32,
	QB_BOOL_I64_I32_ELE,
	QB_GATH_2X_U32_I64_I64,
	QB_GATH_3X_U32_I64_I64,
	QB_GATH_4X_U32_I64_I64,
	QB_GATH_5X_U32_I64_I64,
	QB_GATH_6X_U32_I64_I64,
	QB_GATH_7X_U32_I64_I64,
	QB_GATH_8X_U32_I64_I64,
	QB_SCAT_2X_U32_I64_I64,
	QB_SCAT_3X_U32_I64_I64,
	QB_SCAT_4X_U32_I64_I64,
	QB_SCAT_5X_U32_I64_I64,
	QB_SCAT_6X_U32_I64_I64,
	QB_SCAT_7X_U32_I64_I64,
	QB_SCAT_8X_U32_I64_I64,
	QB_CLR_SCA_I64,
	QB_CLR_ARR_RSZ_U32_I64,
	QB_CLR_ARR_RSZ_DIM_U32_U32_I64,
	QB_CLR_ELE_RSZ_U32_U32_U32_I64,
	QB_CLR_ELE_RSZ_DIM_U32_U32_U32_U32_I64,
	QB_CCLR_ARR_I32_I64,
	QB_CCLR_ELE_U32_U32_I32_I64,
	QB_PRN_S64,
	QB_PRN_S64_SCA = QB_PRN_S64,
	QB_PRN_S64_ELE,
	QB_PRN_S64_MIO,
	QB_PRN_DIM_S64_U32,
	QB_APP_VAR_S64_U32_U08,
	QB_APP_VAR_S64_U32_U08_SCA = QB_APP_VAR_S64_U32_U08,
	QB_APP_VAR_S64_U32_U08_ELE,
	QB_APP_VAR_S64_U32_U08_MIO,
	QB_APP_VAR_DIM_S64_U32_U32_U08,
	QB_PACK_LE_I64_U08,
	QB_PACK_LE_I64_U08_SCA = QB_PACK_LE_I64_U08,
	QB_PACK_LE_I64_U08_ELE,
	QB_PACK_BE_I64_U08,
	QB_PACK_BE_I64_U08_SCA = QB_PACK_BE_I64_U08,
	QB_PACK_BE_I64_U08_ELE,
	QB_UNPACK_LE_U08_I64,
	QB_UNPACK_LE_U08_I64_SCA = QB_UNPACK_LE_U08_I64,
	QB_UNPACK_LE_U08_I64_ELE,
	QB_UNPACK_BE_U08_I64,
	QB_UNPACK_BE_U08_I64_SCA = QB_UNPACK_BE_U08_I64,
	QB_UNPACK_BE_U08_I64_ELE,
	QB_CONV_STR_U08_S64,
	QB_CONV_STR_U08_S64_SCA = QB_CONV_STR_U08_S64,
	QB_CONV_STR_U08_S64_ELE,
	QB_MOV_U64_F32,
	QB_MOV_U64_F32_SCA = QB_MOV_U64_F32,
	QB_MOV_U64_F32_ELE,
	QB_MOV_U64_F32_MIO,
	QB_MOV_U64_F64,
	QB_MOV_U64_F64_SCA = QB_MOV_U64_F64,
	QB_MOV_U64_F64_ELE,
	QB_MOV_U64_F64_MIO,
	QB_PRN_U64,
	QB_PRN_U64_SCA = QB_PRN_U64,
	QB_PRN_U64_ELE,
	QB_PRN_U64_MIO,
	QB_PRN_DIM_U64_U32,
	QB_APP_VAR_U64_U32_U08,
	QB_APP_VAR_U64_U32_U08_SCA = QB_APP_VAR_U64_U32_U08,
	QB_APP_VAR_U64_U32_U08_ELE,
	QB_APP_VAR_U64_U32_U08_MIO,
	QB_APP_VAR_DIM_U64_U32_U32_U08,
	QB_CONV_STR_U08_U64,
	QB_CONV_STR_U08_U64_SCA = QB_CONV_STR_U08_U64,
	QB_CONV_STR_U08_U64_ELE,
	QB_MUL_MM_GUARD_U32_U32,
	QB_MUL_MV_GUARD_U32_U32,
	QB_MUL_VM_GUARD_U32_U32,
	QB_SM_GUARD_U32_U32,
	QB_TRAN_GUARD_U32_U32_U32,
	QB_CROSS_2X_GUARD_U32_U32,
	QB_CROSS_3X_GUARD_U32_U32,
	QB_CROSS_4X_GUARD_U32_U32_U32,
	QB_VV_GUARD_U32_U32,
	QB_TIME_F64,
	QB_TIME_F64_SCA = QB_TIME_F64,
	QB_TIME_F64_ELE,
	QB_EXT_U32,
	QB_DBG_SYNC_U32,
	QB_OPCODE_COUNT
};
